*****************************************************************************
* Modulname  :	FC Flag Catalog
* Modultype  :	Library
* Dest.Comp. :	HP48
* Language   :	System RPL with parts of Machine Code
* Author     :	Raymond Hellstern, Liebigstr.8, 30163 Hannover
* Interface  :	FC
* Description:	Just try...
* Keywords   :	FC
*
* Stack	     :	FC			-->
*
* Notes	     :	Extracted version of FC
*
*
*		THIS CODE IS COPYRIGHTED 1998 BY :
*
*		Raymond Hellstern of Magic48ges
*
*
* To Do	     :
*
*	Version	Date		ED	Reason
*
*	0.00	03.07.98	RH	Extract FC from FORM
*****************************************************************************
	TITLE	Flags Lib

	STITLE	FC	FC :4.198'RH

*****************************************************************************
*		ROM ID DEFINITIONS ->	1430
*****************************************************************************
xROMID		596

ASSEMBLE
*FCflag		EQU	0	* 0: Internal FC not included in lib
FCflag		EQU	1	* 0: Internal FC not included in lib

FCROMID		EQU	#596
RPL
RPL

*****************************************************************************
*		INCLUDE FILES
*****************************************************************************
	INCLUDE	D:\RPL\TL\HEADER.H

*****************************************************************************
*		EXTERNAL DEFINITIONS
*****************************************************************************
EXTERNAL	xFC
EXTERNAL	FheadBar

EXTERNAL	FCTFDead
EXTERNAL	FCstatit

*EXTERNAL	sSSTK

*****************************************************************************
*		CONFIG
*****************************************************************************


*** FCcfg *******************************************************************
* Interface :	( --> )
* Description :	Attach this library and configure the system
* Ed. History :
*     1.000	01.03.1992	DM	start
*****************************************************************************
ASSEMBLE
=FCcfg
RPL
::	[#] FCROMID DUP OFFSRRP	( *Detach any other lib with same ID* )
	TOSRRP	( *Autoattach* )
;

ASSEMBLE
=FCmsg
RPL
ARRY
[
	"PRESS [CONT] FOR MENU"		( *McontFM* )
	"FORM v4.098'RH"		( *Mcopyrt* )
	"OBS IN "			( *Mobsin* )
	"DIRECTORIES:"			( *Mdirs:* )
	"NEW VARIABLE"			( *MnewVar* )
	"OBJECTS IN "			( *Mobjectsin* )
	"Mem Available:\0A  "		( *MmemAv* )
	" bytes"			( *Mbytes* )
	" Vars"				( *Mvars* )
	"Any Object"			( *ManyOb* )
	"VALID OBJECT TYPE"		( *MvaldObT* )
]

*****************************************************************************
*		OBJECTS
*****************************************************************************


*** FC **********************************************************************
* Interface :	( --> )
* Description :	Flag catalog v3
* Ed. History :
*     1.000	22.04.1992	RH	start
*     2.000	21.01.1993	RH	rewrote with SMASH64
*		23.01.1993	RH	debug
*		25.07.1993	RH	GX compatible
*     3.000	10.06.1995	RH	Speed-up, pack
*
*
* To Do:	Review SMASH64
*
*****************************************************************************
ASSEMBLE
	 CON(1)  8
noFC?	IFNE	FCflag
RPL
xNAME	 FC
:: CK0 POLSaveUI
   ERRSET
   :: RECLAIMDISP

**LAM 13	FCmove	X:1-8	Y:1-8
	'
	::
CODE
	GOSBVL	=popflag
	GONC	FCnoUP

	GOSUB	FXpop2#
	C=C-1	A
	?C#0	A
	GOYES	FCnWrp

	C=B	A
	A=A-1	A
	?A#0	A
	GOYES	FCnWrp

	A=B	A
	GONC	FCnWrp		** B.E.T.

FCnoUP	GOSUB	FXpop2#
	C=C+1	A
	?C<=B	A
	GOYES	FCnWrp

        C=C-B	A
	A=A+1	A
	?A<=B	A
	GOYES	FCnWrp

	A=A-B	A

FCnWrp	GOVLNG	=Push2#ACLoop

FXpop2#	GOSBVL	=POP2#
	RSTK=C
	GOSBVL	=SAVPTR
	C=0	A
	LCHEX	8
	B=C	A
	C=RSTK
	RTNCC
ENDCODE

	6PICK DUP		( *Level 6 MUST contain a keycode !* )
CODE
	GOSBVL	=POP#
	?ABIT=0	0
	GOYES	FCtrue

FCtrue	GOVLNG	=OverWrT/FLp
ENDCODE

	IT
	::  DROP FCRow@
	;

** This sub displays the new cursor, then deletes the old one so there's
** a cursor in the display even at high scroll speed.
** It's like a 'comet cursor'
**
	    2DUP		( *x y x' y' x' y'* )
	    FCbigbar		( *x y x' y'* )
	    FCRow!		( *x y x'* )
	    DUP			( *x y x' x'* )
	    FCCol!		( *x y x'* )
	    3PICK		( *x y x' x* )
	    #=?SKIP		( *x y flag* )
	    ::	FCDMode? NOT?SEMI
		FCGETDESC		( *x y* )
		2DROP FCCol@ FCRow@	( *x' y'* )
	    ;

	    FCbigbar
	;


**LAM 12	Ftog
	'
	::  TakeOver
	    ONE
	    FCCol@ DUP#1- #8* FCRow@ #+
	    FCSys? ITE
	    ::	DUP UserITE
		    ClrUserFlag
		    SetUserFlag
	    ;

	    TogSysFlag
	    FCYXBar
	    FCDMode?
		?SWAP

	    FCALL?
	    FCYXBar
	;


**LAM 11	MdITE
	'
	::  ITE
	    ::	FCGETDESC ;
	    ::	SEVEN FORTYNINE BLANKIT
		ONE EIGHT FCALL?
	    ;

	    FCYXBar
	    SetDA3Bad
	;


**LAM 10	FCYXBar
	'
	::  FCCol@ FCRow@ FCbigbar
	;

**LAM 9  FCbigbar		X Y -->
	'
	::  HARDBUFF			( *x y HB* )
	    UNROTSWAP			( *HB y x* )
	    #1- SIXTEEN #* #3+

	    FCDMode? IT
	    ::	DROP THREE
	    ;

	    SWAP#1- #6* #7+
	    3PICK3PICK 3PICKOVER	( *HB X Y HB X Y X* )

	    THIRTEEN #+OVER #7+		( *HB X Y HB X Y X+13 Y+7 * )
	    SUBGROB INVGROB
	    4UNROLL GROB!
	;


**LAM 8 	FCGETDESC
	'
	::  SEVEN FORTYNINE BLANKIT
	    FCCol@  DUPONE FCALL?		( *Smash flag cols to HB left edge* )

*ASSEMBLE
*=sCLEAR		EQU	2
*RPL


***********************************************
**
**	This code can be optimized:
**
**
**FCtx1	CON(2)	(FCtx2)-(*)
**	NIBASC	\Principal Solution\
**FCtx2
**
**	can be packed:
**
**FCtx1	CON(1)	((FCtx2)-(*))/2
**	NIBASC	\Principal Solution\
**FCtx2
**
**	since nibbles in NIBASC are always even
**
**	Saving: ~60 bytes...
***********************************************
CODE
	GOSBVL	=POP#		(1-8)
	A=A-1	A		(0-7)
	GOSBVL	=SAVPTR
	C=A	A
	A=A+C	A				2#
	A=A+C	A				3#	(Cause: REL(3) below)
	GOSUB	FCgtREL	+
	REL(3)	FCtx1	|
	REL(3)	FCtx9	|
	REL(3)	FCtx17	|
	REL(3)	FCtx25	|
	REL(3)	FCtx33	|
	REL(3)	FCtx41	|
	REL(3)	FCtx49	|
	REL(3)	FCtx57	|
*			|	A	B	C	D	Dn	Rn
FCgtREL	C=RSTK	<-------+	3grp-1		&REL1
	C=C+A	A				&RELn
	D1=C							1:&REL
	A=0	A
	A=DAT1	3		RELn		&RELn
	C=C+A	A				&group_n
	D1=C							1:&group

	GOSBVL	=D0->Row1	&row1				0:&row1
	C=0	A
	LC(2)	(2*34)+4
	A=A+C	A
	LC(2)	(6*34)				rowofs
	P=	15
	LCHEX	7		* Loop count
	P=	0				1 rowofs
	ACEX	W		1 rowofs	&row1
	ST=0	sCLEAR

*****************************
FC_Lp	R3=A			1 rowofs	&row1
	C=C+A	A				&row1+ofs
	D0=C							0:&row_n+ofs
	RSTK=C
	AD1EX
	D1=A			D1:&skip-over nib
	C=0	A
	C=DAT1	1				#Skip-over (bytes)
	D1=D1+	1						1:&Chr1
	C=C+C	A				#Chars
	A=A+C	A		* Unpack packed skip-over
	A=A+C	A
	A=A+1	A
	R4=A			* Save &Next_Skip-over_field
	A=0	A
	LAHEX	22		* Row width
	B=0	A		* Pixel offset
	B=B+1	A		*
	B=B+1	A		*

** $->3x5 *******************
*	A[A]:	w width in nibs
*	B[0]:	c col offset (0-3)
*	C[A]:	#Chrs (len$)
*	D0:	&target
*	D1:	&Chr1
*****************************

	GOSBVL	=$->3x5
	C=R4					&Next_Skip-over_field
	D1=C
	C=RSTK					&row_n+ofs
	A=R3			n rowofs
	A=A-1	S
	GONC	FC_Lp
*****************************

	GOVLNG	=GETPTRLOOP
*
*	CAVEAT: Each $ sequence MUST have an even char count !!!
*
*			  1	    2
*		 123456789012345678901234
*		                 <-------
FCtx1	CON(1)	((FCtx2)-(*))/4
	NIBASC	\Principal Solution\
FCtx2	CON(1)	((FCtx3)-(*))/4
	NIBASC	\Symbolic Constants\
FCtx3	CON(1)	((FCtx4)-(*))/4
	NIBASC	\Numerical Results \
FCtx4	CON(1)	((FCtx5)-(*))/4
	NIBASC	\RPL uses Disassembler\
FCtx5	CON(1)	((FCtx6)-(*))/4
	NIBASC	\Wordsize 1\
FCtx6	CON(1)	((FCtx7)-(*))/4
	NIBASC	\Wordsize 2\
FCtx7	CON(1)	((FCtx8)-(*))/4
	NIBASC	\Wordsize 4\
FCtx8	CON(1)	((FCtx9)-(*))/4
	NIBASC	\Wordsize 8\

FCtx9	CON(1)	((FCtx10)-(*))/4
	NIBASC	\Wordsize 16 \
FCtx10	CON(1)	((FCtx11)-(*))/4
	NIBASC	\Wordsize 32 \
FCtx11	CON(1)	((FCtx12)-(*))/4
	NIBASC	\BIN or HEX\
FCtx12	CON(1)	((FCtx13)-(*))/4
	NIBASC	\OCT or HEX\
FCtx13	CON(1)	((FCtx14)-(*))/4
	NIBASC	\RPL lib. quiet\
FCtx14	CON(1)	((FCtx15)-(*))/4
*	NIBASC	\STK6 active \
	NIBASC	\G: TVM: END MODE\
FCtx15	CON(1)	((FCtx16)-(*))/4
	NIBASC	\Polar \
FCtx16	CON(1)	((FCtx17)-(*))/4
	NIBASC	\Spherical \

FCtx17	CON(1)	((FCtx18)-(*))/4
	NIBASC	\Radians \
FCtx18	CON(1)	((FCtx19)-(*))/4
	NIBASC	\Grads \
FCtx19	CON(1)	((FCtx20)-(*))/4
	NIBASC	\2D Complex\
FCtx20	CON(1)	((FCtx21)-(*))/4
	NIBASC	\U-flow Exception Error\
FCtx21	CON(1)	((FCtx22)-(*))/4
	NIBASC	\O-flow Exception Error\
FCtx22	CON(1)	((FCtx23)-(*))/4
	NIBASC	\Inf Result: +/- 1E500 \
FCtx23	CON(1)	((FCtx24)-(*))/4
	NIBASC	\Neg. U-flow Indicator \
FCtx24	CON(1)	((FCtx25)-(*))/4
	NIBASC	\Pos. U-flow Indicator \

FCtx25	CON(1)	((FCtx26)-(*))/4
	NIBASC	\O-flow Indicator\
FCtx26	CON(1)	((FCtx27)-(*))/4
	NIBASC	\Inf Result Indicator\
FCtx27	CON(1)	((FCtx28)-(*))/4
	NIBASC	\SysStack active / Sym.Decmp.\
FCtx28	CON(1)	((FCtx29)-(*))/4
	NIBASC	\5/7 stk / G: Multi-Plot \
FCtx29	CON(1)	((FCtx30)-(*))/4
	NIBASC	\sys-edit / G: Trace mode\
FCtx30	CON(1)	((FCtx31)-(*))/4
	NIBASC	\G: Parameterized Plot \
FCtx31	CON(1)	((FCtx32)-(*))/4
	NIBASC	\Curve Filling Off \
FCtx32	CON(1)	((FCtx33)-(*))/4
	NIBASC	\XOR Cursor\

FCtx33	CON(1)	((FCtx34)-(*))/4
	NIBASC	\I/O to IR Port\
FCtx34	CON(1)	((FCtx35)-(*))/4
	NIBASC	\Print to Serial Port\
FCtx35	CON(1)	((FCtx36)-(*))/4
	NIBASC	\Binary I/O\
FCtx36	CON(1)	((FCtx37)-(*))/4
	NIBASC	\RECV Overwrite\
FCtx37	CON(1)	((FCtx38)-(*))/4
	NIBASC	\Double-Spaced Print \
FCtx38	CON(1)	((FCtx39)-(*))/4
	NIBASC	\Auto LF \
FCtx39	CON(1)	((FCtx40)-(*))/4
	NIBASC	\I/O Messages Off\
FCtx40	CON(1)	((FCtx41)-(*))/4
	NIBASC	\Clock Display \

FCtx41	CON(1)	((FCtx42)-(*))/4
	NIBASC	\24 Hr Clock \
FCtx42	CON(1)	((FCtx43)-(*))/4
	NIBASC	\European Date Fmt \
FCtx43	CON(1)	((FCtx44)-(*))/4
	NIBASC	\Rpt Alms Not Rescheduled\
FCtx44	CON(1)	((FCtx45)-(*))/4
	NIBASC	\Acknowledged Alms Saved \
FCtx45	CON(1)	((FCtx46)-(*))/4
	NIBASC	\Display Rnd 1 \
FCtx46	CON(1)	((FCtx47)-(*))/4
	NIBASC	\Display Rnd 2 \
FCtx47	CON(1)	((FCtx48)-(*))/4
	NIBASC	\Display Rnd 4 \
FCtx48	CON(1)	((FCtx49)-(*))/4
	NIBASC	\Display Rnd 8 \

FCtx49	CON(1)	((FCtx50)-(*))/4
	NIBASC	\FIX or ENG\
FCtx50	CON(1)	((FCtx51)-(*))/4
	NIBASC	\SCI or ENG\
FCtx51	CON(1)	((FCtx52)-(*))/4
	NIBASC	\Fraction Mark , \
FCtx52	CON(1)	((FCtx53)-(*))/4
	NIBASC	\Single-Line Display \
FCtx53	CON(1)	((FCtx54)-(*))/4
	NIBASC	\Show All () \
FCtx54	CON(1)	((FCtx55)-(*))/4
	NIBASC	\G: Singular val u-flow\
FCtx55	CON(1)	((FCtx56)-(*))/4
	NIBASC	\Last Args Not Saved \
FCtx56	CON(1)	((FCtx57)-(*))/4
	NIBASC	\BEEP & Error Beep Off \

FCtx57	CON(1)	((FCtx58)-(*))/4
	NIBASC	\Alarm Beep Off\
FCtx58	CON(1)	((FCtx59)-(*))/4
	NIBASC	\Verbose MESSAGES Off\
FCtx59	CON(1)	((FCtx60)-(*))/4
	NIBASC	\Fast Catalog Display\
FCtx60	CON(1)	((FCtx61)-(*))/4
	NIBASC	\Alpha Lock / English units\
FCtx61	CON(1)	((FCtx62)-(*))/4
	NIBASC	\User Mode Lock / NO Units \
FCtx62	CON(1)	((FCtx63)-(*))/4
	NIBASC	\User Mode Active\
FCtx63	CON(1)	((FCtx64)-(*))/4
	NIBASC	\Vectored ENTER\
FCtx64	CON(1)	((FCtx65)-(*))/4
	NIBASC	\Index Wrap Indicator\
FCtx65
ENDCODE
	;












**LAM 6  FCDMode?
**LAM 5  FCSys?
	FalseFalse

**LAM 4  Y
**LAM 3  X
	ONEONE

**LAM 2
	'
	:: FCSys?

******************************************************************
*
*  SMASH64 - The main flag display	( # Cols Sys? --> )
*					(#:1-8 ; Cols:1-8 ; Sys? flag)
*
*  - VERY fast
*  - Only SUPPORTED entries
*
*  - Display ALL 64 User/System flags (with marker if set)
*
*	1.0	21.01.1993	RH	wrote
*	1.1	23.01.1993	RH	modified & stabilized
*	2.0	21.08.1993	RH	and also GX
*
******************************************************************
    ITE ZERO ONE

*  #COL COLOUMNS System/User
CODE
	GOSBVL	=POP#		1
	ASRC			* A[S]:1/0
	GOSBVL	=POP2#		* A[A]:#Col
	A=A-1	A
	C=C-1	A
	CSRC			* C[S]:Coloumns-1
	GOSBVL	=SAVPTR
	D1=(5)	=S_SysFlags
	D0=(5)	(=INHARDROM?)+14
        C=DAT0  B
	?CBIT=0 3
	GOYES	FCsmshS

	D1=(5)	G_SysFlags	* SystemFlags GX

FCsmshS	?A#0	S		* 0: User ; 1: System
	GOYES	FCisSys

	D1=D1+	16		* =UserFlags

FCisSys	B=A	A	Cols	Cols
	A=0	A	0
	A=A+1	A	1
	GONC	FCshfF

FCshFlg	D1=D1+	2
	A=A+CON B,8

FCshfF	B=B-1	A
	GONC	FCshFlg

	C=0	A		* C[S]:#Col
	LCHEX	125		* Offset into VDISP
	B=C	A
	D0=(5)	(=addrADISP)+2
	C=DAT0	A
	D0=C
	C=DAT0	A
	C=C+B	A

****************************************
* This loop may be run up to 8 times
*
* IN : C[A]:&HB+ofs  C[S]:ColCount
* D1 : &User/SystemFlags
*
*
*
****************************************
FCmainL	R3=C			* R3[S]:Cols ; R3[A]:&HB+ofs
	D0=C
	D=0	S
	D=D+CON S,7		* Loop offset;Floop is run 8 times
	C=DAT1	B		* Get byte from User/SystemFlags
	D1=D1+	2		* Advance to next byte
        D=C     B

****************************************
* Floop
*
*
* IN :	A[A]: Char
*	B[S]: 4 Rows to write
*	C
*	D[B]: User/System Flag Data
*	D0:   &(VDISP+ofs)
*	D1:   &User/SystemFlags+ofs
*
* OUT:
*
* USE:	A[W],B[S],C[W]
*	R2,R4,D0,P,ST8
*       SystemFlags
****************************************
FCFloop	R0=A
	C=D	B
	?CBIT=0 0
        GOYES   FCnobox

	LCHEX	07770		* BOX packed pixel data
	GONC	FCbx/bk		* B.E.T.

FCnobox	C=0	A

FCbx/bk	R4=C
	DSRB.F	B		* Shift User/System Flag Data

****************************************
* Split char into 2 displayable parts,
* if value of char > Ah
****************************************
	ST=0	8
	C=0	A
	LCHEX	A
	?A<C	B
	GOYES	FClessA		* Only ONE digit to display

	ST=1	8
	B=0	A
	GONC	FCminit		* B.E.T.

FCmin10	B=B+1	A		1

FCminit	A=A-C	B	  A-10d
	GONC	FCmin10

****************************************
* TWO digits to display
****************************************
FCminX	A=A+C	B
	ABEX	B	1?	A-10d
	GOSUB	FCgtpxD
	R2=A
	A=0	A
	A=B	B

FClessA	GOSUB	FCgtpxD
	B=0	S
	B=B+CON S,4
	C=0	W

****************************************
* bangnum  -  Bang the given pixel data
*	      into VDISP
*
*
* IN :	A[A]: Short pixel data
*	B[S]: 4 Rows to write
*	C
*	D[B]: User/System Flag Data
*	D1:   &(VDISP+ofs)
*
* OUT:
*
* USE:	A[W],B[S],C[W]
*	R2,R4,D0,P,ST8
*	SystemFlags
*
****************************************
FCbngnm	AR4EX
	C=A	P
	ASRC
	AR4EX
	CSLC
	C=A	P
	CSLC
	?ST=0	8
	GOYES	FCno2nd

	AR2EX
	C=A	P
	ASRC
	AR2EX

FCno2nd	ASRC
	DAT0=C	X
	D0=D0+	16
	D0=D0+	16
	D0=D0+	2		* D0:&NextRow
	B=B-1	S
	GONC	FCbngnm
****************************************

	D0=D0+	16
	D0=D0+	16
	D0=D0+	2		* D0:&NextRow
	A=R0
	A=A+1	A
	R0=A
	D=D-1	S
	GOC	FCnext

	GOTO	FCFloop
****************************************

FCnext	C=R3
	C=C+CON A,4
	C=C-1	S
	GOC	FCexit

	GOTO	FCmainL

FCexit	GOVLNG	=GETPTRLOOP

****************************************
* getpixD  -  Get packed pixel data
*
* IN :	A[A]: val
* OUT:	A[A]: pixdat
* USE:	A[A],C[A],D1,RSTK(1)
*
****************************************
** SHORT PIXEL DATA
*0     1     2	   3	 4     5     6	   7	 8     9

FCgtpxD C=A	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	GOSUB	FCget
	NIBHEX	25552	*0
	NIBHEX	32227	*1
	NIBHEX	74717	*2
	NIBHEX	74747	*3
	NIBHEX	55744	*4
	NIBHEX	71747	*5
	NIBHEX	61757	*6
	NIBHEX	74211	*7
	NIBHEX	75757	*8
	NIBHEX	75747	*9

FCget	C=RSTK
	C=C+A	A
	CD1EX
	A=DAT1	A
	D1=C			* Restore Flag Pointer
	RTNCC
ENDCODE

	;


**LAM 1  Exit Flag
**	FALSE

	FClams nNullBIND

	ONE EIGHT FCALL?
	FCYXBar FCstatit

	SetDA3Bad		( *Force draw menu keys* )

**Level 9
	'
	::  DA3OK? ?SEMI
	    DispMenu SetDA3Valid
	;

**Level 8
	'
	::  ONE #=casedrop
	    ::	DUP#<7 casedrpfls
		ELEVEN ?CaseKeyDef
		::  TakeOver REPEATERCH ELEVEN
		    ::	FCCol@ FCRow@ 2DUP
			TRUE FCmove
		    ;
		;

		SIXTEEN ?CaseKeyDef
		::  TakeOver REPEATERCH SIXTEEN
		    ::	FCCol@ FCRow@ OVER	( *x y x* )
			ONE TRUE FCmove
		    ;
		;

		SEVENTEEN ?CaseKeyDef
		::  TakeOver REPEATERCH SEVENTEEN
		    ::	FCCol@ FCRow@ 2DUP
			FALSE FCmove
		    ;
		;

		EIGHTEEN ?CaseKeyDef
		::  TakeOver REPEATERCH EIGHTEEN
		    ::	FCCol@ FCRow@ OVER	( *x y x* )
			EIGHT FALSE FCmove
		    ;
		;

		TWENTYSIX ?CaseKeyDef
		::  TakeOver FCtog
		;

		FORTYFIVE ?CaseKeyDef
                ::  TakeOver TRUE FCExit!
		;

		FCTFDead
*		    THIRTYFIVE #=casedrpfls
*		    FORTY #=casedrpfls
*		    DROPDEADTRUE
	    ;

	    TWO #=casedrop

*		TFDead
NULLNAME  FCTFDead
		::
		    THIRTYFIVE #=casedrpfls
		    FORTY #=casedrpfls
		    DROPDEADTRUE
		;

	    THREE #=casedrop
	    ::
		FORTYFIVE #=casedrpfls
		FCTFDead
*		    THIRTYFIVE #=casedrpfls
*		    FORTY #=casedrpfls
*		    DROPDEADTRUE
	    ;

	    2DROP 'DoBadKeyT
	;

**Level 6&7
	TrueTrue

**Level 5
	{
	    {	"+/-"
		::  TakeOver FCtog
		;

	    }
	    {	::  TakeOver
		    FCSys? ITE
			NULL$
		    :: FCDMode? ITE	"ALL"	"DESC"
		    ;
		;

		::  TakeOver
		    FCSys? caseDEADKEY
		    FCDMode? NOT DUP FCDMode!
		    FCMdITE
		;
	    }
	    {	::  TakeOver
		    FCDMode? ITE
			NULL$
		    ::	FCSys? ITE	"SYS"	"USER"
		    ;
		;

		::  TakeOver
		    FCDMode? caseDEADKEY
		    SetDA3Bad
		    FCSys? NOT FCSys!

NULLNAME  FCstatit
		    ::	FCSys? ITE	"User"	"System"

			" FLAGS" &$
*	FheadBar
*NULLNAME  FheadBar		( *Draw shaded headbar and title* )
		    ::	TOADISP
CODE
	GOSBVL	=SAVPTR
	GOSBVL	=D0->Row1
	LCHEX	5555555555555555
	A=C	W
	A=A+A	W
	P=	(16-7)		** Seven loops to do

CBarLp	DAT0=C	W
	D0=D0+	16
	DAT0=C	W
	D0=D0+	16
	DAT0=C	B
	D0=D0+	2
	ACEX	W		** Prepare for shifted checkers line
	P=P+1
	GONC	CBarLp		** On exit: P=0

	GOVLNG	=GETPTRLOOP
ENDCODE
			DUPNULL$? caseDROP
			$>grob DUPGROBDIM
			#3+ SWAP#1+SWAP MAKEGROB
			ZEROZERO # 70 SEVEN SUBGROB
			DUPGROBDIM SWAPDROP BINT_131d
			SWAP#- #2/ UNROT 3PICKSWAP
			ZEROSWAP XYGROBDISP
			SWAP #2+ SWAP
			ONESWAP XYGROBDISP
			SetDA1Valid
		    ;


		    ;

		    FCYXBar
		    ONE EIGHT
		    FCALL?
		    FCYXBar
		;
	    }

	}

**Level 3&4
**Level 2
        ONEFALSE' FCExit

**Level 1
	'ERRJMP

	ClrDA1IsStat
	POLSetUI POLKeyUI
	ABND
    ;
   ERRTRAP
     POLResUI&Err
   POLRestoreUI ClrDAsOK DispMenu
;

ASSEMBLE
noFC?	ENDIF
RPL


************************************************************
*NULLNAME  sSSTK
*SSTK
