*****************************************************************************
* Modulname  :	FORMSPECS
* Modultype  :	Library
* Dest.Comp. :	HP48
* Language   :	System RPL with parts of Machine Code
* Author     :	Raymond Hellstern, Liebigstr.8, 30163 Hannover
* Interface  :	TIMEX
* Description:	Just try...
* Keywords   :	MB, MODES, TIMEX
*
* Stack	     :	xTIMEX			-->
*
*			ALMCat
*			ALMSet
*			TIMESet
*
* Notes	     :
*		This shell replaces the G model built-in standard time-related
*		forms by very fast versions.
*		This code is optimized for speed and temporary memory usage.
*		This means a garbage collection will happen a few keystrokes
*		later than usual. As a side effect, code size was reduced, too.
*
*
*		DecompOb can be found in IFUTIL.S
*
*		THIS CODE IS COPYRIGHTED 1998 BY :
*
*		Raymond Hellstern of Magic48ges
*
*
* To Do	     :	Include all formspecs here...
*		Restrict levels of NEW->CHOOSE->... ()
*
*
*	Version	Date		ED	Reason
*
*	0.00	10.03.98	RH	Start as separate library
*		21.04.98	RH	Add MB, MODES
*****************************************************************************
	TITLE	FORMSPEC Lib

	STITLE	FS	FMSPEC :4.098'RH

*****************************************************************************
*		ROM ID DEFINITIONS ->	182
*****************************************************************************
xROMID		B6

ASSEMBLE
*FCflag		EQU	0	* 0: Internal FC not included in lib
FCflag		EQU	1	* 0: Internal FC not included in lib

FSROMID		EQU	#B6
RPL
RPL

*****************************************************************************
*		INCLUDE FILES
*****************************************************************************

INCLUDE	HEADER.H
INCLUDE	FORM.RP
INCLUDE	L224.RP
INCLUDE	FORM_DEF.H
INCLUDE	FORM_EQU.H
INCLUDE	FS_DEF.H
INCLUDE	FS_EQU.H
INCLUDE	BROWSER.H

*****************************************************************************
*		DEFINES
*****************************************************************************
DEFINE          FS_Alarm?	1GETLAM
DEFINE		#FS_Elements	ELEVEN
DEFINE		#FS_SoftKeys	NINE

*****************************************************************************
*		EXTERNAL DEFINITIONS
*****************************************************************************

EXTERNAL	FSmsg[]@

*----------------------------------- Memory/Modes related objects
EXTERNAL	xMB

EXTERNAL	xMODES
EXTERNAL	FmodesSB1
EXTERNAL	FmodDspF
EXTERNAL	FmodesSB2

*EXTERNAL	Fkey{}STD
EXTERNAL	FcopyVAR
EXTERNAL	FcpmvCM
EXTERNAL	FmoveVAR

EXTERNAL	DoMemBR
EXTERNAL	MBRnoOb$
EXTERNAL	MBRnoOb$?

EXTERNAL	MBRestart
EXTERNAL	{$}>{id}

EXTERNAL	CopyVar
EXTERNAL	MoveCopyVar
EXTERNAL	CheckPathObj
EXTERNAL	MoveVar
*EXTERNAL	PurgeVar


*----------------------------------- Time/Alarm related objects
EXTERNAL	xTIMEX

EXTERNAL	ALMCat
EXTERNAL	ALMSet
EXTERNAL	TIMESet
EXTERNAL	ATDSet

EXTERNAL	TM_GetLbls[]
*EXTERNAL	TM_DMY_Labels[]
*EXTERNAL	TM_MDY_Labels[]

EXTERNAL	TM_GetHelp[]
*EXTERNAL	TM_DMY_Help[]
*EXTERNAL	TM_MDY_Help[]

EXTERNAL	TM_DMYSwpInfo

EXTERNAL	DecompMinute
EXTERNAL	DecompSeconds
EXTERNAL	DecompHour
EXTERNAL	DecompMonth
EXTERNAL	DecompDay

EXTERNAL	DecompOb2
EXTERNAL	DecompNoNL

*EXTERNAL	MonthOfDays
EXTERNAL	5Years
*-----------------------------------

EXTERNAL	xABOUT

*****************************************************************************
*		CONFIG
*****************************************************************************

*** FScfg *******************************************************************
* Interface :	( --> )
* Description :	Attach this library and configure the system
* Ed. History :
*     1.000	07.08.1991	DM	start
*****************************************************************************
ASSEMBLE
=FScfg
RPL
::	[#] FSROMID DUP OFFSRRP	( *Detach any other lib with same ID* )
	TOSRRP	( *Autoattach* )
;

ASSEMBLE
=FSmsg
RPL
NULLNAME  FSmsg[]@
ARRY
[
*	"PRESS [CONT] FOR MENU"		( *McontFM* )
	"FORMSPECS v4.098'RH"		( *Mcopyrt* )

*	"OBS IN "			( *Mobsin* )
*	"DIRECTORIES:"			( *Mdirs:* )
*	"NEW VARIABLE"			( *MnewVar* )
*	"OBJECTS IN "			( *Mobjectsin* )
*	"Mem Available:\0A  "		( *MmemAv* )
*	" bytes"			( *Mbytes* )
*	" Vars"				( *Mvars* )
*	"Any Object"			( *ManyOb* )
*	"VALID OBJECT TYPE"		( *MvaldObT* )
]

*****************************************************************************
*		OBJECTS
*****************************************************************************

xNAME  MB
::  CK0 DoMemBR

;




*
* FcopyVAR, FmoveVAR
*
* NAME:		id	: 1 var (current)
*		{}	: n vars selected
*
* xxxx TO:	id	: dir name; create if nonexistent
*			  overwrite existing vars in target dir
*		{}	: target path list
*
* id id			: copy/move var to new name
*
* id {}			: copy/move var to dir
*
* {} id			: copy/move vars to dir
*
* {} {}			: copy/move vars to dir


*
* ob --> ?
*
NULLNAME  FcopyVAR
::
**TITLE
	"COPY VARIABLE(S)"		( *ob {} ? $* )

**LBL
ARRY
    [	"" "NAME" "COPY TO"
    ]					( *ob {} ? $ []* )

	"" 4ROLL			( *{} ? $ [] ob* )

**TEXT

	"" THREE {}N			( *{} ? $ [] {tx}* )

**HELP
ARRY
[	""
	"ENTER NAMES OF VARS TO COPY"
	"ENTER VAR NAME OR DIRECTORY PATH"
]					( *{} ? $ [] {tx} [hlp]* )


NULLNAME  FcpmvCM
	::

***MENU
**	    Fkey{}STD

*NULLNAME  FkeyChDIR

{	::  TakeOver "CHOOS" Fsf2# FmenuLBL?
	;

	::  TakeOver Fsf2# FmenuKEY?

	    ONE
	    DOchuDIRS NOT?SEMI
	    PATHDIR# SWAPDROP

	    FputItem?
	;

}

	TWO Fkey{}STD PUTLIST			( *Patch key list* )

	5UNROLL


*EXTERNAL HARD KEY DEFS:
	'NOP
	5UNROLL

**FrstDL
	'
	::
ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	((Fd3)+(Fd2))
RPL
		FdspList! THREE Findex!
	;


**FdspList
ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	((Fd3)+(Fd2))
RPL


**FcurIt{}@
*    {
*	"" "" ""			( *No ob, no name, no directory* )
*    }
	4PICK



**RESET
    {
	"" "" ""			( *No ob, no name, no directory* )
    }


*
* ROWCOL
*
ASSEMBLE
	CON(5)	=DOEXT0
	REL(5)	FcoEndCPY
	CON(2)	#3		* 6-Tupel count
***
	CON(2)	#1		* Count: Row 1

	CON(2)	#1		* Col1
	CON(2)	#8		* Col2
	CON(2)	#20		* Col3
	CON(2)	(FTEdit)+(FTChoose)	* FldT
	CON(5)	ObTid		* ObT=Name ('Identifier')
	CON(3)	((Fsf1)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))	* Menu?
***
	CON(2)	#1		* Count: Row 2

	CON(2)	#1		* Col1
	CON(2)	#8		* Col2
	CON(2)	#20		* Col3
	CON(2)	FTEdit		* FldT
	CON(5)	(ObT{})+(ObTid)	* ObT=Name ('Identifier' or {List})
	CON(3)	((Fsf1)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))	* Menu?
***
	CON(2)	#1		* Count: Row 3

	CON(2)	#1		* Col1
	CON(2)	#8		* Col2
	CON(2)	#20		* Col3
	CON(2)	(FTEdit)+(FTChoose)	* FldT
	CON(5)	(ObT{})+(ObTid)	* ObT=Name ('Identifier' or {List})
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))	* Menu?
***
	CON(2)	#0		* Count: Row 4
FcoEndCPY
RPL

	THREE				( *Initial focus* )
	xFORM				( *[..] --> [..]' T | F* )

	ClrDAsOK			( *Signal redraw background* )
*	NOT?SEMI
	NOTcaseFALSE

	ROTDROP				( *DROP AWAY DUMMY ARG* )

	DUPTYPELIST? OVER TYPEIDNT? OR	( *[..] id id' flag1* )
	NOTcase2drop
	::  [#] argtypeerr xALERT FALSE
	;

	OVER TYPELIST? 3PICK TYPEIDNT? OR ( *[..] id id' flag1 flag2* )
	NOTcase2drop
	::  [#] argtypeerr xALERT FALSE
	;

	TRUE
    ;

    NOT?SEMI

*    SWAP DUPTYPEIDNT? IT
*	ONE{}N
*
*    SWAP

    CopyVar
;




*
* ob --> ?
*
NULLNAME  FmoveVAR
::
**TITLE
	"MOVE VARIABLE(S)"		( *ob {} ? $* )

**LBL
ARRY
    [	"" "NAME" "MOVE TO"
    ]					( *ob {} ? $ []* )

	""
	4ROLL				( *{} ? $ [] ob* )
**TEXT
	""
	THREE {}N

**HELP
ARRY
[	""
	"ENTER NAMES OF VARS TO MOVE"
	"ENTER VAR NAME OR DIRECTORY PATH"
]


    FcpmvCM

    NOT?SEMI
    MoveVar
;




NULLNAME  DoMemBR
::
*    CK0
    TRUE { LAM 'MBRexit } BIND

    BEGIN
    ::	TRUE' LAM 'MBRexit STOLAM		( *Preset to allow exit* )
	DoVars{$} ?SKIP

NULLNAME  MBRnoOb$
	{ "- No Objects -" }
	Mobjectsin JstGETTHEMSG
	PATHDIR DO>STR &$ # 5B FitLeft$ DROPSWAP
        { %1 }

	{  ::

*NULLNAME  MBRdoMENU?
*	    ::
		TakeOver

*
* --> T|F
*
NULLNAME  MBRnoOb$?
		::  BRC1@ MBRnoOb$ EQUAL
		;

		case NULL$
*	    ;

		"EDIT" MakeDirLabel
	    ;

	    ::	TakeOver MBRnoOb$? caseDoBadKey
	    ;
	}

	{   "CHOOS"					( *Eventually change dir* )
	    ::	TakeOver

		ONE
*	BRCurRow@
*
* WE HAVE TO PROVIDE AN INDEX FOR THE CURRENT DIR:
*

		DOchuDIRS NOT?SEMI
		PATHDIR# SWAPDROP COMPEVAL		( *Set new resolution* )

NULLNAME  MBRestart
		::  FALSE' LAM 'MBRexit STOLAM		( *Restart MemBR* )
		    BRdone %0
		;
	    ;
	}

	{   ::	TakeOver MBRnoOb$? case NULL$
		Multi@ ITE
		  FgrobChk				( *Checkmark + "CHK"* )
		  NULL$
	    ;

	    ::	TakeOver MBRnoOb$? caseDoBadKey
		MBRtog
	    ;
	}

	{   ::	TakeOver
		"NEW" MakeDirLabel
	    ;
	    ::	TakeOver
		BRsave16 FnewVAR BRrest16
                IT
		    MBRestart
	    ;
	}

	{   ::	TakeOver MBRnoOb$? case NULL$
		"COPY" MakeDirLabel
	    ;
	    ::	TakeOver MBRnoOb$? caseDoBadKey
		BRsave16

*	{#}>{%}
NULLNAME  {$}>{id}
		::
*		    ENTER
		    BRenterM DROPFALSE BRExtFlg!

		    INNERDUP
		    ZERO_DO (DO)
			DUP #1+ROLL $>ID SWAP
		    LOOP
		    {}N

		    DUPLENCOMP #1= case
			INCOMPDROP
		;

		FcopyVAR

		BRrest16
	    ;
	}

	{   ::	TakeOver MBRnoOb$? case NULL$
		"MOVE" MakeDirLabel
	    ;

	    ::	TakeOver MBRnoOb$? caseDoBadKey
		BRsave16 {$}>{id} FmoveVAR BRrest16
	    ;
	}

	{   ::	TakeOver MBRnoOb$? case NULL$
		"RCL"
	    ;

	    ::	TakeOver MBRnoOb$? caseDoBadKey	( *Empty Dir* )
	    ;
	}

	{   ::	TakeOver MBRnoOb$? case NULL$
		"PURG"
	    ;

	    ::	TakeOver MBRnoOb$? caseDoBadKey
		{$}>{id}

**MAYBE ASK FOR DELETE W/POSSIBILTY TO SUPRESS FURTHER CHECKING

*		PurgeVar
**
** Purge variable(s)
**
** (no FVAL_NULL)
*NULLNAME PurgeVar
*  ( idVar | { idVars } --> )
*::
		DUPTYPEIDNT? ITE
		    ?PURGE_HERE
		    XEQPURGE{}
*;
		MBRestart
	    ;
	}

	{   "SIZE"
	    ::	TakeOver MBRnoOb$? ITE
		    NULL$

		::  {$}>{id}
		    ::	DUP DUPTYPELIST? ITE
			    INNERCOMP
			    ONE
* ob|[id..id] #count
			ZEROSWAP		( *id #0 #1* )
			DUP#0=csDROP		( *id #0 #1* )
			ZERO_DO (DO)
			  SWAP VARSIZE SWAPDROP
			  COERCE #+
			LOOP			( *$ #size* )
		    ;
* ob #size
		    #>$
		    SWAP DUPTYPELIST? ITE
		    ::	LENCOMP #>$
			Mvars JstGETTHEMSG &$
		    ;
			ID>$

		    CHR_: >T$ "\0A  " &$ SWAP&$	( *$[name:\0Asize]* )
		    Mbytes JstGETTHEMSG
		    &$ NEWLINE&$		( *$[name:\0Asize bytes\0A]* )
		;

		GARBAGE MEM #2/ #>$		( *$ $#size* )

		MmemAv JstGETTHEMSG SWAP&$ &$
		Mbytes JstGETTHEMSG &$
		xMBOX
	    ;
	}

	' NullMenuKey

	BRKeyCancel
	BRKeyOK

	TWELVE {}N			( *This is for SX compatibility* )
	DoBrowse
	%1 %= caseDROP
    ;

    LAM 'MBRexit

    UNTIL
    ABND
;




NULLNAME CopyVar
  ( SrcVar[s] [ idDestVar | idDestDir | { DestDirPath } ] --> )
::  'NOP MoveCopyVar
;


**
** Stack:  SourceVar[s] Destination CodeObj  -->
**
** Note: the stack diagram for CodeObj is ( id obj --> id obj )
**
NULLNAME MoveCopyVar	( [idSrc | {}Src] [idDest | {}Dest] CodeObj --> )
::  UNROTSWAP
**    FvalNullChk 	( Code dest src )
    SWAP
**    FvalNullChk 		( Code src dest )

    DUPTYPEIDNT?
    IT
	ONE{}N

    DUPNULLCOMP? caseSIZEERR
    ZEROZERO			( Code src {dest} #0 #0 )
    5ROLL CONTEXT@ 		( src {dest} #0 #0 Code context )
    4NULLLAM{} BIND		( src {dest} )
    ERRSET
    ::
* find the destination directory
* Note: the input path list must NOT be null!
*
* Error Exits: "Bad Argument Value" if a path element is not legal
*		"Nonexistent"       if a path id (except last one) doesn't exist
*
* Check the objects in the path list, erroring out if not HOME, UPDIR, or a
* directory "id" (the last object can be any "id").
* EVAL the path list to get to the new context.
*
	INNERCOMP			( src ob1 .. obn #n )
	#1-SWAP				( src ob1 .. obn-1 #n-1 obn )
	OVER #2+UNROLL			( src obn ob1 .. obn-1 #n-1 )
	DUP#0=ITE
	    DROP
	::  ZERO_DO (DO)		( src obn ob1 .. obn-1 )
		ISTOP-INDEX ROLL	( src obn ob2 .. obn-1 ob1 )
		CheckPathObj		( src obn ob2 .. obn-1 [T | id flag F] )
		NOTcase
		::  caseSIZEERR SETNONEXTERR
		;
	    LOOP
	;				( src obn )

	CheckPathObj			( src [T | id T F | id F F] )
	CONTEXT@ UNROT		( DestContext src T | src obn/id DC flg F )
	ITE
	    ZEROSWAP 		( DestContext #0 src )
	::  DROP UNROTSWAP  	( DestContext idDest src )
* Here: The destination is a nonexistent "id" or a non-directory "id".
* If SrcVar[s] is a list of 2 or more elements, then error out
	    DUPTYPELIST? NOT?SEMI
	    DUPLENCOMP		( DestContext idDest {src} #NumObs )
	    #1= ?SEMI		( DestContext idDest {src} )
	    ROTDROP		( idDest {src} )
	    SWAPDUP		( {src} idDest idDest )
	    CREATEDIR		( {src} idDest )
	    XEQRCL		( {src} DestContext' )
	    SWAP ZEROSWAP	( DestContext' #0 {src} )
	;

* loop through the source list, processing one object at a time
	DUPTYPELIST?
	ITE INNERCOMP ONE	( DestContext Dest Src1 .. Srcn #n )
	DUP#0=csDROP
	ZERO_DO (DO)		( DCntxt Dest Src1 .. Srcn )
* verify that this source object is an "id"
	DUPTYPEIDNT? NcaseTYPEERR
	DUP StoSrcId
* get its' object
	GetSrcContext CONTEXT!	( DCntxt Dest Src1 .. Srcn id )
	DUP XEQRCL		( DCntxt Dest Src1 .. Srcn id obj )
	DUP StoSrcOb
* do purge for Move
	2GETLAM EVAL		( DCntxt Dest Src1 .. Srcn id obj )
	ERRSET
	::
* switch to the destination context
	    ISTOP-INDEX		( DCntxt Dest Src1 .. Srcn id obj #NumSrc )
	    #3+PICK		( DCntxt Dest Src1 .. Srcn id obj DCntxt )
	    CONTEXT!		( DCntxt Dest Src1 .. Srcn id obj )
* use destination variable name if given, else use source name
	    ISTOP-INDEX
	    #2+PICK		( DCntxt Dest Src1 .. Srcn id obj Dest )
	    DUP#0=ITE
	      DROPSWAP 		( DCntxt Dest Src1 .. Srcn obj id )
	      ROTDROP		( DCntxt Dest Src1 .. Srcn obj idDest )
	    STRIPTAGSl2 ?STO_HERE	( DCntxt Dest Src1 .. Srcn )
	;
	ERRTRAP
	::  GetSrcContext CONTEXT! GetSrcOb GetSrcId
	    2GETLAM TYPECOL? IT ?STO_HERE ERRJMP
	;
	LOOP
    ;
    ERRTRAP
    ::	1GETABND CONTEXT! ERRJMP
    ;

    1GETABND CONTEXT!		( DCntxt Dest )
    2DROP

    MBRestart
;



**
** Check the object for legality as a element of a path list.
**
** Returns:
**	if not "id", HOME, or UPDIR:		type error
**	if directory "id", HOME, or UPDIR:	TRUE
**	if other variable "id":			id TRUE FALSE
**	if nonexistent "id" (SAFE@ failed):	id FALSE FALSE
**
NULLNAME CheckPathObj
::				( obj --> id F | obj T )
   DUPTYPEIDNT?			( obj flag )
   case
     :: DUPSAFE@		( id [obj T | F] )
        NOTcase FalseFalse	( id F F )
	TYPERRP?		( id [T | F] )
	NOTcase TrueFalse	( id T F )
	EVAL TRUE		( TRUE )
      ;
*    ' xHOME
    RESOROMP xHOME		( *THIS IS A PATCH* )

    OVER EQ			( obj flag )
    ' xUPDIR 3PICK EQOR		( obj flag )
    NOTcase SETTYPEERR
    EvalNoCK TRUE		( TRUE )
;

**
** Move variable(s) to another variable or directory
**
** If more than one source variable is moved, the destination (id or path)
** must be an existing directory.
**
** SrcVar[s] is either an id or a list of objects (supposedly ids, but must
** be checked).
** Only look for idDestDir in the current directory, but its' existence must
** be checked.
**
** The DestDirPath is typed in by the user so all the components must be
** checked.  The first component can be HOME and UPDIR is also legal.
** It can end in a variable name if only one source was
** given or in a directory name (which means the variable name isn't changed).
**
NULLNAME MoveVar
  ( SrcVar[s] [ idDestVar | idDestDir | { DestDirPath } ] --> )
::
   ' :: DUPTYPERRP? 3PICKSWAP ITE SETDIRACCERR ?PURGE_HERE ;
   MoveCopyVar
;


*****************************************************************************
*	FMODES		The modes FORMSPEC
*
*	This program provides all necessary parameters for the FORM engine.
*	Believe me, there are many ;-)
*
*	Level	Contents
*
*	12	{Menu keys}
*	11	:: External hard keys ;
*	10	"Title"
*	9	[Field labels]
*	8	{Field text}	May be a list of lists; see below
*	7	["Field help"]
*	6	:: Reset fields procedure part 1 ;
*	5	# Display_list	(Each bit set indicates an active field)
*	4	{ Current items for each field }
*	3	{ Reset items }
*	2	LibData[ Field & menu key properties ]	(see below)
*	1	# Initial_Item
*
*	call FORM
*
*	False			if form cancelled
*	{ Item values } True	if form accepted
*
*****************************************************************************

*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	MODES
::  CK0

**MENU
	FkeyEdit
	FkeyChoose
	FkeyChk
***********
	{	::  TakeOver "FLAG" MakeDirLabel
		;

		::  TakeOver xFC
		    RECLAIMDISP
		    ClrDAsOK		( *Signal redraw whole display* )
		;
	}
***********

	FlblCNCOK			( *FkeyCancel, FkeyOK* )

	FkeyReset
	FkeyCalc
	FkeyTypes

    NINE {}N


*EXTERNAL HARD KEY DEFS:
* #kc #kp --> ?

'
::
	kpLeftShift #=casedrop
	::	kcMathMenu ?CaseExtKey	( *Switch DEG/RAD* )
		::	THREE FmodesSB2
		;
		kpLeftShift		( *Restore stack: #kc #kp* )
	;

	kpRightShift #=casedrop
	::	kcMathMenu ?CaseExtKey	( *Switch RECT/POLAR* )
		::	FOUR FmodesSB2
		;
		kpRightShift		( *Restore stack: #kc #kp* )
	;

;


**TITLE
    "CALCULATOR MODES"

**LBL
ARRY
    [
	"NUMBER FORMAT"  ""		( *DON'T USE 'NULL$'* )
	"ANGLE MEASURE" "COORD SYSTEM"
	"BEEP" "CLOCK" "FM,"
    ]

**TEXT
    {
	{

** This first element is a list of lists, where the first object will be
** displayed during 'CHOOS', the second in the form.
** The third object is the update-anything procedure.
** this procedure can do *anything*, so watch your parameters!
** It returns T if all right; F if re-indexing has to be done
	{
	 "Standard" "Std"
	::  FdspList@

ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	(Fd2)
RPL

	    2DUP #AND #0=
*	    case2drop
*		TRUE			( *NO, do NOT update Idx* )
	    case2DROP


CODE
	GOSBVL	=POP#
	A=-A-1	A		* #NOT
	GOVLNG	=#PUSHA-
ENDCODE
	    #AND
	    FmodDspF			( *Yes, update Idx* )

	    Findex@
ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	(Fd2)
RPL
	    #<> ?SEMI

	    ONE Findex!
	;

	}

	{	"Fixed"		"Fix"	FmodesSB1	}
	{	"Scientific"	"Sci"	FmodesSB1	}
	{	"Engineering"	"Eng"	FmodesSB1	}

	}

	{ %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 %11 %12 }

	{ "Degrees" "Radians" "Grads" }
	{ "Rectangular" "Polar" "Spherical" }
	NULL$ NULL$ NULL$
    }

**HELP
ARRY
[	"CHOOSE NUMBER DISPLAY FORMAT" "ENTER DECIMAL PLACES TO DISPLAY"
	"CHOOSE ANGLE MEASURE" "CHOOSE COORDINATE SYSTEM"
	"ENABLE STANDARD BEEP?" "DISPLAY TICKING CLOCK?"
	"USE COMMA AS FRACTION MARK?"
]


**FrstDL
	'
	::
ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	((Fd7)+(Fd6)+(Fd5)+(Fd4)+(Fd3)+(Fd1))
RPL
		FdspList!
		ONE Findex!
	;


**FdspList
ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	((Fd7)+(Fd6)+(Fd5)+(Fd4)+(Fd3)+(Fd1))
RPL

**FcurIt{}@

********************************************
* This code will return the state of
* s15,s16 (Polar, Spheric)
* s17,s18 (DEG, RAD, GRAD)
* s49,s50 (mode)
* and s45-s48 (rounding)
*
*
*
*
*	Mode	49	50	Sum	Item
*	------------------------------------
*	STD	0	0	0	1
*	FIX	1	0	1	2
*	SCI	0	1	2	3
*	ENG	1	1	3	4
CODE
	GOSBVL	=SAVPTR
	GOSBVL	=GetAngleMode	* CAVEAT: This sub uses C=P 0!! See src
	P=	0		* P value depended on C[0] value, so reset
	SETHEX			* GetAngleMode selected DEC mode
	C=0	A
	C=DAT0	1		* DEG, RAD, GRAD
	CBIT=0	2
	CBIT=0	3
	C=C+1	A
	R4=C
	D0=D0-	1		* &ComVecDiNib
	C=DAT0	1
	CSRB.F	B
	CSRB.F	B		* Bit0:POLAR	Bit1:SPHERIC	None:Rectangular
	?C#0	P
	GOYES	FnotRCT

	C=C+1	A

FnotRCT	R3=C
	D0=D0+	8		* &Display_rounding
	C=DAT0	1
	C=C+1	A		* #display_rounding
	D0=D0+	1
	A=0	A
	A=DAT0	1
	ABIT=0	2
	ABIT=0	3
	A=A+1	A		* #mode
	R0=A
	R1=C
	GOSBVL	=PUSH2#
	GOSBVL	=SAVPTR
	C=R3
	A=R4
	GOVLNG	=Push2#ACLoop		( *#FMT # #Angle #Coord* )
ENDCODE


******
*        ROTDROP { % 17 ONE } UNROT
******



    fnErrorBeep	TestSysFlag NOT		( *#FMT # #Angle #Coord Beep?* )
    fnClockOn	TestSysFlag		( *#FMT # #Angle #Coord Beep? Clock?* )
    fnRadix	TestSysFlag		( *#FMT # #Angle #Coord Beep? Clock? FM?* )

    SEVEN {}N


    DUPONE NTHCOMPDROP #1=?SKIP		( *Eventually update Displist* )
    ::	SWAP

ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	(Fd2)
RPL
	#+SWAP
    ;


**RESET
    {	ONE ONE ONE ONE			( *Std, 0 digits, DEG, Rectangular* )
	TRUE FALSE FALSE		( *Mode checks* )
    }


*
* ROWCOL
*
*INCLUDE	FORM_DEF.H

ASSEMBLE
	CON(5)	=DOEXT0
	REL(5)	FcoEndMDS
	CON(2)	#7		* 6-Tupel count
***
	CON(2)	#2		* Count: Row 1

	CON(2)	#1		* Col1
	CON(2)	#F		* Col2
	CON(2)	#14		* Col3
	CON(2)	FTChoose	* FldT
	CON(5)	ObTnone		* ObT=None
	CON(3)	((Fsf2)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))	* Menu?

	CON(2)	#13
	CON(2)	#15
	CON(2)	#19
	CON(2)	(FTChoose)+(FTEdit)	* FldT
	CON(5)	ObTreal		* ObT	1: Real
	CON(3)	((Fsf1)+(Fsf2)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))
***
	CON(2)	#1		* Count: Row 2

	CON(2)	#1
	CON(2)	#F
	CON(2)	#1A
	CON(2)	FTChoose	* FldT
	CON(5)	ObTnone		* ObT
	CON(3)	((Fsf2)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))
***
	CON(2)	#1		* Count: Row 3

	CON(2)	#1
	CON(2)	#F
	CON(2)	#20
	CON(2)	FTChoose	* FldT
	CON(5)	ObTnone		* ObT
	CON(3)	((Fsf2)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))
***
	CON(2)	#3		* Count: Row 4

	CON(2)	#1
	CON(2)	#5
	CON(2)	#5
	CON(2)	FTCheck		* FldT
	CON(5)	ObTnone		* ObT = 0: Check/Choose
	CON(3)	((Fsf3)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))

	CON(2)	#C
	CON(2)	#13
	CON(2)	#15
	CON(2)	FTCheck		* FldT
	CON(5)	ObTnone		* ObT
	CON(3)	((Fsf3)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))

	CON(2)	#17
	CON(2)	#16
	CON(2)	#1E
	CON(2)	FTCheck		* FldT
	CON(5)	ObTnone		* ObT
	CON(3)	((Fsf3)+(Fsf4)+(Fsf5)+(Fsf6)+(Fsf.1))
ASSEMBLE
FcoEndMDS
RPL

    ONE					( *Initial focus* )

    xFORM				( *[..] --> [..]' T | F* )

    NOT?SEMI


**FORM EXIT PROC [OK] FprocOK
**
** This procedure sets all modes as chosen in FORM
*	'

**Stk:	( *#mode #dsp_rnd #GRD #ComVec _BEEP _CLK _FM,* )

	    fnRadix	SWAP	ITE	SetSysFlag	ClrSysFlag
	    fnClockOn	SWAP	ITE	SetSysFlag	ClrSysFlag
	    fnErrorBeep	SWAP	ITE	ClrSysFlag	SetSysFlag

CODE
*	GOSBVL	=POP#		* 0:Rect	2:Polar		3:Spheric
	GOSBVL	=POP2#		* 0:Rect	2:Polar		3:Spheric
	R1=A			* DRG

	RSTK=C			* Save RPS
	GOSBVL	=SAVPTR
	GOSBVL	=GetAngleMode	* CAVEAT: This sub uses C=P 0!! See src
	P=	0		* P value depended on C[0] value, so reset!
	SETHEX			* GetAngleMode selected DEC mode.

	A=R1
	A=A-1	A		* Base 0

	C=DAT0	1
	CBIT=0	0
	CBIT=0	1

	A=A!C	P
	DAT0=A	1

	C=RSTK

	?CBIT=1	1
	GOYES	Fnottt

	CBIT=0	0

Fnottt	C=C+C	A
	C=C+C	A
	D0=D0-	1
	A=DAT0	1
	ABIT=0	2
	ABIT=0	3
	C=C!A	P
	DAT0=C	1
	GOVLNG	=GETPTRLOOP
ENDCODE

    DUPTYPELIST? IT
    ::	CARCOMP %ABSCOERCE	( *{% #} --> % --> #* )
	ELEVEN #MIN #1+		( *Normalize: 0<=x<=11* )
    ;

    #1-SWAP ONE #=casedrop
    ::	DROP DOSTD
    ;

    TWO		#=casedrop	DOFIX
    THREE	#=case		DOSCI
    DOENG
;


NULLNAME  FmodesSB1
::  FdspList@ DUP FmaxAItems	( *DL #* )
    SEVEN #=
*    casedrptru		( *casedrop TRUE* )
    caseDROP

ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	(Fd2)
RPL

CODE
	GOSBVL	=POP2#
	A=A!C	A		* #OR
	GOVLNG	=#PUSHA-	* This is a pack (does SAVPTR, PUSH, LOOP)
ENDCODE


NULLNAME  FmodDspF
    ::	FdspList!
	SEVEN NINE BLANKIT
	Findex@ Fdspfield	( *Disp this field...* )
    ;

    Findex@ #1+ Fdspfield	( *...and the parameter field* )
;

NULLNAME  FmodesSB2
::  FcurIt{}@ DUP		( *#n {} {}* )
    3PICK NTHCOMPDROP		( *#n {} #* )
    TWO #=ITE			( *{} # # #2* )
	ONE			( *#n {} #1* )
	TWO			( *#n {} #2* )

    3PICK			( *#n {} #2 #n* )
    ROT PUTLIST			( *#n #2 #n {} --> #n {}'* )
    FcurIt{}!			( *#n* )
    DUP Findex@ #= IT
    ::	DUP Finvertbar
    ;

    DUP Fdspfield
    DUP Findex@ #<> ITE_DROP
	Finvertbar
;

**MENU	(NOT SAVED IN FORM-LAM, BUT POL)

**TITLE
**LBL
**TEXT
**HELP

**FdspList
**FrstDL
**FcurIt{}@
**RESET

**Fprop[]
**FORM EXIT PROC [OK] FprocOK
**INITIAL











*****************************************************************************
*	TIME	The TIME FORMSPEC
*
*	This program provides all necessary parameters for the FORM engine.
*	Believe me, there are many ;-)
*
*	Level	Contents
*
*	12	{Menu keys}
*	11	:: External hard keys ;
*	10	"Title"
*	9	[Field labels]
*	8	{Field text}	May be a list of lists; see below
*	7	["Field help"]
*	6	:: Reset fields procedure part 1 ;
*	5	# Display_list	(Each bit set indicates an active field)
*	4	{ Current items for each field }
*	3	{ Reset items }
*	2	LibData[ Field & menu key properties ]	(see below)
*	1	# Initial_Item
*
*	call FORM
*
*	False			if form cancelled
*	{ Item values } True	if form accepted
*
*****************************************************************************

*****************************************************************************

ASSEMBLE
	CON(1)	8
RPL
xNAME	TIMEX
::  CK0
    ""	{ "Browse alarms\1F" "Set alarm\1F" "Set time, date\1F"	}
    TWO DOstdCHU NOT?SEMI
    DUP #1= casedrop	ALMCat
    #2= case		ALMSet
    TIMESet
;


NULLNAME  ALMCat
::
;

NULLNAME  ALMSet
::  "ALARM" TRUE ATDSet
;


NULLNAME  TIMESet
::  "TIME AND DATE" FALSE ATDSet
;


NULLNAME  ATDSet
::  { NULLLAM } BIND

**MENU
    FkeyEdit FkeyChoose FkeyChk
***********
    NullMenuKey
***********
    FkeyCancel FkeyOK
    FkeyReset FkeyCalc FkeyTypes

    #FS_SoftKeys {}N


*EXTERNAL HARD KEY DEFS:
* #kc #kp --> ?

    'NOP

**TITLE
*    "TIME"
    ROT "SET " SWAP&$			( *{SfKeys} ':: $Title* )

**LBL					( *DON'T USE 'NULL$'* )

NULLNAME  TM_GetLbls[]
    ::	fnDateFmt SysITE
ARRY
    [
	"MESSAGE" "TIME" " :" " :" ""
	"DATE" " ." " ." "" "REPEAT" ""
    ]

ARRY
    [
	"MESSAGE" "TIME" " :" " :" ""
	"DATE" " /" " /" "" "REPEAT" ""
    ]
    ;


**TEXT

**$Message
    NULL$
*""

**%Hour		(0-23)
    { %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 %11 %12 %13 %14 %15 %16 %17 % 18 % 19 % 20 % 21 % 22 % 23  }

**%Minute	(00-59)
**%Second	(00-59)

**
** Make a list of %0...%59
**
*NULLNAME %0To%59		( --> { %0 %1 ... %59 } )
    ::	SIXTY
	ZERO_DO (DO) INDEX@ UNCOERCE
	LOOP
	SIXTY {}N
    ;

    DUP

**TimeFmt
    {
	{    "AM" "AM" :: ;			}
	{    "PM" "PM" :: ;			}
	{    "24-hour time" "24-hr" :: ;	}
    }



*fnDateFmt SysITE
**%Day		(1-31 w/Day-name)
    { %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 %11 %12 %13 %14 %15 %16 %17 % 18 % 19 %20 %21 %22 %23  }

**%Month	(1-12 w/Month-name)
    { %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 %11 %12 %13 %14 %15 %16 %17 % 18 % 19 %20 %21 %22 %23  }

**%Year		(%current_year - %curr+5)
    { %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 %11 %12 %13 %14 %15 %16 %17 % 18 % 19 %20 %21 %22 %23  }


**DateFmt
    {
	{    "Month/Day/Year" "M/D/Y" :: TM_DMYSwpInfo   ;	}
	{    "Day.Month.Year" "D.M.Y" :: TM_DMYSwpInfo  ;	}
    }




**
**FROM HERE: EXPERIMENTAL !!!!
**

**%Repeat	(0-10	0 is displayed as 'None')
    { %1 %2 %3 %4 %5 %6 %7 %8 %9 %10 }



*	{
*
*** This first element is a list of lists, where the first object will be
*** displayed during 'CHOOS', the second in the form.
*** The third object is the update-anything procedure.
*** this procedure can do *anything*, so watch your parameters!
*** It returns T if all right; F if re-indexing has to be done
*	{
*	 "Standard" "Std"
*	::  FdspList@
*
*ASSEMBLE
*	CON(5)	=DOBINT
*	CON(5)	(Fd11)
*RPL
*	    2DUP #AND #0= case2DROP	( *NO, do NOT update Idx* )
*
*CODE
*	GOSBVL	=POP#
*	A=-A-1	A		* #NOT
*	GOVLNG	=#PUSHA-
*ENDCODE
*	    #AND
*	    FmodDspF			( *Yes, update Idx* )
*
*	    Findex@
*ASSEMBLE
*	CON(5)	=DOBINT
*	CON(5)	(Fd11)
*RPL
*	    #<> ?SEMI
*
*	    ELEVEN Findex!
*	;
*
*	}
*
**	{	"Fixed"		"Fix"	FmodesSB1	}
**	{	"Scientific"	"Sci"	FmodesSB1	}
**	{	"Engineering"	"Eng"	FmodesSB1	}
*
*	}



**
** END EXPERIMENTAL
**





**%RepFactor

DUP
*    { "Week" "Day" "Hour" "Minute" "Second" }

    #FS_Elements {}N



**HELP

NULLNAME  TM_GetHelp[]
    ::	fnDateFmt SysITE
ARRY
[	"ENTER ALARM MESSAGE" "ENTER HOUR" "ENTER MINUTE" "ENTER SECOND"
	"CHOOSE AM, PM, OR 24-HOUR TIME"
	"ENTER DAY" "ENTER MONTH" "ENTER YEAR" "CHOOSE DATE DISPLAY FORMAT"
	"ENTER ALARM REPEAT MULTIPLE" "ENTER ALARM REPEAT UNIT"
]
ARRY
[	"ENTER ALARM MESSAGE" "ENTER HOUR" "ENTER MINUTE" "ENTER SECOND"
	"CHOOSE AM, PM, OR 24-HOUR TIME"
	"ENTER MONTH" "ENTER DAY" "ENTER YEAR" "CHOOSE DATE DISPLAY FORMAT"
	"ENTER ALARM REPEAT MULTIPLE" "ENTER ALARM REPEAT UNIT"
]
    ;

**Default for next two parms is TIME:


**FdspList

    FS_Alarm? ITE
ASSEMBLE
	CON(5)	=DOBINT
*	CON(5)	((Fd11)+(Fd10)+(Fd8)+(Fd7)+(Fd6)+(Fd5)+(Fd4)+(Fd3)+(Fd2)+(Fd1))
	CON(5)	((Fd10)+(Fd8)+(Fd7)+(Fd6)+(Fd5)+(Fd4)+(Fd3)+(Fd2)+(Fd1))
RPL

ASSEMBLE
	CON(5)	=DOBINT
	CON(5)	((Fd9)+(Fd8)+(Fd7)+(Fd6)+(Fd5)+(Fd4)+(Fd3)+(Fd2))
RPL

    DUP' FdspList!
    FS_Alarm? ITE
	ONE
	TWO
    ' Findex!
    FOUR ::N
    SWAP

**FrstDL FdspList



***FcurIt{}@ RESET

*Message $
*    ""
    NULL$

**
** Get current time
**
*NULLNAME GetTimeTime			( --> %Hour %Min %Sec PC<Postfix> )
    ::	TOD				( %hh.mmss )
*NULLNAME XlatTime
	::  DUP %IP SWAP		( %Hour %hh.mmss )
	    %FP %100 %*			( %Hour %mm.ss )
	    DUP %IP SWAP		( %Hour %Min %mm.ss )
	    %FP %100 %* %IP		( %Hour %Min %Sec )

*	TimePostfixes
	    ::	fnClockFmt TestSysFlag
		case THREE		( %Hour %Min %Sec {} )
		4PICK %12 %> ITE
		::  4ROLL %12 %- 4UNROLL TWO
		;
		::  4PICK %12 %= case TWO
		    4ROLL DUP%0= IT :: DROP %12 ;
		    4UNROLL ONE
		;
	    ;
*	NTHCOMPDROP
	;
    ;


**
** Get current date	(and bint for DateFmt)
**
*NULLNAME GetTimeDate			( --> %Month %Day %Year )
    ::	DATE				( %MM.DDYYYY )
*NULLNAME XlatDate
	::  DUP %IP SWAP %FP %100 %*	( %Month %DD.YYYY )
	    DUP %IP SWAP %100 %*	( %Month %Day %YY.YY )
	    %FP %100 %*			( %Month %Day %Year )
*
* In the off chance that the date format is set to DD.MMYYYY
* we need to swap the month and day objects:
*
	    fnDateFmt TestSysFlag ITE :: ROTSWAP TWO ; ONE
	;
    ;


    ONE ZERO

**
** $"" %Hour %Min %Sec #PC<Postfix> %Month %Day %Year #Fmt #1 #0
**

    #FS_Elements {}N DUP

*ABND TRUE ?SEMI


*
* ROWCOL
*
ASSEMBLE
	CON(5)	=DOEXT0
	REL(5)	FcoEndTIM
	CON(2)	#B		* 6-Tupel count
***
	CON(2)	#1		* Count: Row 1

	CON(2)	#1		* Col1
	CON(2)	#8		* Col2
	CON(2)	#1F		* Col3
	CON(2)	FTEdit		* FldT
	CON(5)	ObTany		* ObT=Any object
	CON(3)	((Fsf1)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))	* Menu?
***
	CON(2)	#4		* Count: Row 2

	CON(2)	#1
	CON(2)	#8
	CON(2)	#C
	CON(2)	(FTChoose)+(FTEdit)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#D
	CON(2)	#D
	CON(2)	#11
	CON(2)	(FTChoose)+(FTEdit)+(FTLblNoCh)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#12
	CON(2)	#12
	CON(2)	#16
	CON(2)	(FTChoose)+(FTEdit)+(FTLblNoCh)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#17
	CON(2)	#17
	CON(2)	#1F
	CON(2)	FTChoose		* FldT
	CON(5)	ObTnone			* ObT
	CON(3)	((Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1))
***
	CON(2)	#4		* Count: Row 3

	CON(2)	#1
	CON(2)	#8
	CON(2)	#C
	CON(2)	(FTChoose)+(FTEdit)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#D
	CON(2)	#D
	CON(2)	#11
	CON(2)	(FTChoose)+(FTEdit)+(FTLblNoCh)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#12
	CON(2)	#12
	CON(2)	#16
	CON(2)	(FTChoose)+(FTEdit)+(FTLblNoCh)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#17
	CON(2)	#17
	CON(2)	#1F
	CON(2)	FTChoose		* FldT
	CON(5)	ObTnone			* ObT
	CON(3)	((Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1))
***
	CON(2)	#2		* Count: Row 4

	CON(2)	#1
	CON(2)	#8
	CON(2)	#C
	CON(2)	(FTChoose)+(FTEdit)	* FldT
	CON(5)	ObTreal		* ObT
	CON(3)	((Fsf1)+(Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1)+(Fsf.2)+(Fsf.3))

	CON(2)	#D
	CON(2)	#D
	CON(2)	#F
	CON(2)	FTChoose	* FldT
	CON(5)	ObTnone		* ObT
	CON(3)	((Fsf2)+(Fsf5)+(Fsf6)+(Fsf.1))
*ASSEMBLE
FcoEndTIM
RPL

    FS_Alarm? ITE
	ONE				( *Initial focus* )
	TWO

    xFORM				( *[..] --> [..]' T | F* )
*FALSE

    ABND

    NOT?SEMI


**FORM EXIT PROC [OK] FprocOK
**
** This procedure sets all modes as chosen in FORM
*	'

**Stk:	( *#mode #dsp_rnd #GRD #ComVec _BEEP _CLK _FM,* )


;


**MENU	(NOT SAVED IN FORM-LAM, BUT POL)

**TITLE
**LBL
**TEXT
**HELP

**FdspList
**FrstDL
**FcurIt{}@
**RESET

**Fprop[]
**FORM EXIT PROC [OK] FprocOK
**INITIAL







NULLNAME  TM_DMYSwpInfo
::
*fnDateFmt DUP SysITE
*	ClrSysFlag
*	SetSysFlag

    TM_GetLbls[] Flabel[]!
    TM_GetHelp[] Fhelp[]!

    TWENTYSEVEN SEVEN BLANKIT

    SIX Fdspfield SEVEN Fdspfield
    EIGHT Fdspfield

**Field #9 will automatically be displayed...
*    NINE Fdspfield


fnDateFmt DUP SysITE
	ClrSysFlag
	SetSysFlag


**	Ftext{}@ ' ID TEXX SAFESTO
;









NULLNAME DecompMinute		( %Minutes --> $Minutes )
NULLNAME DecompSeconds		( %Seconds --> $Seconds )
::  CHR_0 DecompOb2
;

NULLNAME DecompHour		( %Hour --> $Hour )
NULLNAME DecompMonth		( %Month --> $Month )
NULLNAME DecompDay		( %Day --> $Day )
::  CHR_Space DecompOb2
;

NULLNAME  DecompOb2
::  SWAPOVER			( *% $ %* )
    StdDecompNoNL		( *% $ "%"* )
    SWAPROT %9 %>		( *"%" $ T|F* )
    caseDROP
    >H$
;

NULLNAME  StdDecompNoNL		( Ob --> $Ob )
::  savefmt1			( save current display format and set standard format )
    ERRSET

*	DecompNoNL		( try to decompile )
NULLNAME  DecompNoNL		( Ob --> $Ob )
::  DUPTYPEIDNT? case
	DECOMP$			( use DECOMP$ for IDs to suppress ticks )

    TWENTYTHREE !DcompWidth
*( ensure no newlines and at least one character beyond maximum standard field width )

    1stkdecomp$w		( decompile )
;
    ERRTRAP
    ::	rstfmt1 ERRJMP
    ;				( if error, restore format and error )

    rstfmt1			( restore format )
;


**
** Calculate a month of days
**
*NULLNAME MonthOfDays		( #Month #Year --> { MonthOfDays } )
*::
* 2DUP CalcLastDay
** 3NULLLAM{}
*  { NULLLAM NULLLAM NULLLAM }
*
* BIND
* 1GETLAM #1+_ONE_DO (DO)
*   INDEX@ DUP DUP #>$ SWAP TEN #< IT :: CHR_Space >H$ ; APPEND_SPACE
*   { M_Monday M_Tuesday M_Wednesday M_Thursday M_Friday M_Saturday M_Sunday }
*   3GETLAM INDEX@ 2GETLAM CalcDayOfWeek
*   NTHCOMPDROP JstGETTHEMSG &$
*   SWAP UNCOERCE TWO{}N
* LOOP
* 1GETABND {}N
*;



**
** Calculate five years
**
NULLNAME 5Years			( %StartYear --> { 5Years } )
::
  DUP COERCE
  FOUR ZERO_DO (DO)
    #1+ ONEHUNDRED #/ DROP DUP UNCOERCE SWAP
  LOOP
  DROP
  FIVE {}N
;







*****************************************************************************
* EACH FIELD HAS THE FOLLOWING PROPERTIES:
*
*	$Flabel		Field title. This may be a NULL$ initially.
*	$Ftext		Field text. This may be a NULL$ initially.
*			Never changed by FORM.
*	$Fhelp		Field help. This may be a NULL$.
*	Fmenu{}		Field menu. This may be a NULL{}.
*	RESET		Reset value.
*	OBT		Valid object type(s)
*	FldT		Field type (Choose, Edit, Check,...)
*	#Frow		Field row. The range is between 0 and 3.
*	#Fcol1		Field start column. The range is between 0 and 33.
*	#Fcol2		Field end column. The range is between 0 and 33.
*	#Fcol3		Field end column. The range is between 0 and 33.
*
*	Menu page codings:
*
*	1st menu page is fully custom.
*	On the 2nd menu page, the first four (from left) keys are custom:
*
*	The rightmost two keys are 'hardwired' to [CANCL] and [OK].
*	The key activation codes are organized as follows:
*
*		sf1	sf2	sf3	sf4	sf5	sf6
*	---------------------------------------------------
*	pg1	1	2	4	8	16	32
*	pg2	64	128	256	512	-	-
*
*	If sf1 has a label, it will only be shown and active if the
*	corresponding key activation bit for the current field is true.
*	For sf1 this code must be binary 1, and so on. To activate all
*	custom keys, the combined code has to be all 1's (11111111b=255d).
*
*	Object type descriptors:
*
*	Valid object types are indicated by a bint, which holds markers for
*	up to 20 ob types since there are 20 bits building a bint.
*
*	Value	Meaning
*	----------------------------------------------------
*	0	Check
*	1	Any type
*
*
*
*	Field columns are counted from left to right.
*	Each column is four pixel wide, so a $Ftext with 6 chars would fit
*	into 8 columns since each char is 6 pixel wide.
*	Example: #Fcol2=0 and #Fcol3=8.
*
*	FcurIt		Field value. This may be any object type initially.
*
*			Fixed list	# as pointer into list
*			Semifixed list	# as pointer into list
*					{ ob  # }
*			Edit field	ob/value
*			Check field	TRUE|FALSE
*
*
*****************************************************************************
*****************************************************************************

xNAME	ABOUT
::
;

************************************************************
*NULLNAME  sSSTK
*SSTK
