ASSEMBLE
	CLRLIST ALL
	SETLIST	MACRO
RPL


**miscdoc+**************************************************
************************************************************
**
**  This file turns off the assembly listing so the contents
**  of "Header.h" are not shown in every listing that
**  includes "Header.h".
**
**  The last file in "Header.h" should be "OnList.h", to
**  turn back on the assembly listing.
**
************************************************************
**+miscdoc**************************************************
RPL		( insure RPL-mode exit )

ASSEMBLE
*** DOSTR$ ******************************************************************
* Interface:
*	ASSEMBLE
*	DOSTR$	<ASCII CHARS>
*	RPL
*
* Result:
*	CON(n)	#len
*	NIBASC	\ASCII CHARS\
*
*
* Descrpition:
*	The following macro could be used to generate a short count for the
*	following string data.
*	If $ < 16, count field (#len) will be 1 nib long.
*	If 16 < $ < 256 , count field will be 2 nibs long.
*
* Caveat:
*	DON'T USE STRINGS LARGER THAN 256 CHARS !
*
*
* Edition History:
*	1.000	29.04.1996	RH	Alpha version
*****************************************************************************
DOSTR1$	MACRO x

	CON(1)	((DSTeT$0)-(DSTaT$0))/2
DSTaT$0	NIBASC	\$1\
DSTeT$0
DOSTR1$	ENDM


DOSTR2$	MACRO x
	CON(2)	((DSTe2$0)-(DSTa2$0))/2
DSTa2$0	NIBASC	\$1\
DSTe2$0
DOSTR2$	ENDM


DOSTR3N	MACRO x
	CON(2)	((DSTe2$0)-(DSTa2$0))/2
DSTa2$0	NIBHEX	$1
	NIBHEX	$2
	NIBHEX	$3
DSTe2$0
DOSTR3N	ENDM


DOSTR4N	MACRO x
	CON(2)	((DSTe2$0)-(DSTa2$0))/2
DSTa2$0	NIBHEX	$1
	NIBHEX	$2
	NIBHEX	$3
	NIBHEX	$4
DSTe2$0
DOSTR4N	ENDM




DOSTR8N	MACRO
	CON(3)	((DSTe2$0)-(DSTa2$0))
DSTa2$0
	NIBHEX	$1
	NIBHEX	$2
	NIBHEX	$3
	NIBHEX	$4
	NIBHEX	$5
	NIBHEX	$6
	NIBHEX	$7
	NIBHEX	$8


DSTe2$0
DOSTR8N	ENDM





DOHXS1$	MACRO x
	CON(1)	((DSTeT$0)-(DSTaT$0))
DSTaT$0	NIBHEX	$1
DSTeT$0
DOHXS1$	ENDM


RPL
RPL




*** SSTK(N) *****************************************************************
* Interface:
*	SSTK	(First call)
*	SSTKN	(Subsequent calls to save space)
*
* Description:
*	The following definition sets a breakpoint in RPL
*	ENTER resumes execution , all other keys abort
* Edition History:
*	1.000	13.08.1991	RH	Alpha version
*****************************************************************************
DEFINE	SSTK	:: HARDBUFF TOTEMPOB 1LAMBIND VSTK WaitForKey DROP ZEROZERO 1GETABND XYGROBDISP TWENTYFIVE #=?SKIP :: AtUserStack ABORT ; FLUSHKEYS ;
DEFINE  SSTKN   SSTK
*** Vstk ****************************************************************
* Shows ( up to ) NINE Stack Levels in small font			*
*   or  ( up to ) SEVEN Stack Levels in medium font                     *
*************************************************************************
DEFINE VSTK  :: DEPTH #0=?SEMI RECLAIMDISP DEPTH DUP EIGHT #<case vstk0 vstk1 ;
DEFINE vstk0 :: SEVEN #MIN #1+_ONE_DO (DO) vstks &$ EIGHT INDEX@#- DISPN LOOP ;
DEFINE vstk1 :: NINE #MIN #1+_ONE_DO (DO) vstks FORTYTHREE 1_#1-SUB$ &$ $>grob ZEROZERO BINT_130d SIX SUBGROB ABUFF ONE NINE INDEX@#- #6* GROB! LOOP ;
DEFINE vstks :: INDEX@ #:>$ INDEX@ #1+PICK DUPTYPECSTR? ?SEMI 1stkdecomp$w ;


*****************************************************************************
* Modulname:	42
* Modultype:	Header file
* Dest.Comp.:	HP-48
* Language:	System RPL
* Author:	Detlef Mueller	Nibelungenweg 6  2000 Hamburg 56 Tel. 040/812398
* Interface:	INCLUDE	42.h
* Description:	Usefull RPL tools
* Edition History :
*	0.000	13.08.1991	DM	Alpha version
*****************************************************************************


    ASSEMBLE

*** MKGROB ******************************************************************
* Interface:
*	ASSEMBLE
*	MKGROB	x,y
*	NIBHEX	nnnnnnnnn ...
*	RPL
* Description:
*	The following macro could be used to generate GROB definitions due
*	the lack of the RPLCOMP built-in command GROB.
* Edition History:
*	1.000	13.08.1991	DM	Alpha version
*****************************************************************************

MKGROB	MACRO		* x,y
	CON(5)	=DOGROB
	CON(5)	15+(($1+7)/8)*$2*2
	CON(5)	$2
	CON(5)	$1
MKGROB	ENDM

*** MKSGROB *****************************************************************
* Interface:
*	ASSEMBLE
*	MKSGROB	x,y,nnnnnnnn ...
*	RPL
* Descrpition:
*	The following macro could be used to generate small GROB definitions
*	(no more than 80 nibbles in hxs field) due the lack of the RPLCOMP
*	built-in command GROB.
* Edition History:
*	1.000	17.08.1991	DM	Alpha version
*****************************************************************************

MKSGROB	MACRO		* x,y,nnnn
	CON(5)	=DOGROB
	CON(5)	15+(($1+7)/8)*$2*2
	CON(5)	$2
	CON(5)	$1
	NIBHEX	$3
MKSGROB	ENDM

*** DOMSG *******************************************************************
* Interface:
*	ASSEMBLE
*	DOMSG	RomId,MsgNr
*	RPL
* Descrpition:
*	The following macro could be used to generate a message number from
*	a given ROMID and message offset.
* Edition History:
*	1.000	25.08.1991	DM	Alpha version
*****************************************************************************

DOMSG	MACRO	* RomId,MsgNr
	CON(5)	=DOBINT
	CON(5)	($1)*256+($2)		* (ROMID << 8) | msgnr *
DOMSG	ENDM







**miscdoc+**************************************************
************************************************************
**
** Default system flag values
**
**   These equates define the system flag values to be used
**   when the machine is reset.  The exact value depends on
**   the system flag number assignments and the individual
**   system flag default values.
**
************************************************************
**+miscdoc**************************************************
ASSEMBLE
DefSysF64-33 EQU	#00000000
DefSysF32-01 EQU	#000003F0
**		"3F" specifies binary integer wordsize of 64;
**		all other flags are clear
RPL

**miscdoc+**************************************************
************************************************************
**
** System flag RPL number assignments
**
**   All states represented by multiple flags should
**   start on a flag number nibble boundary (e.g., 1, 5, ...)
**   for more efficient code.
**
**   All single-bit flags should by default be CLEAR.  For
**   example, the "last arguments" mode is enabled (the default)
**   when "fnLastArgs" is CLEAR.
**
************************************************************
**+miscdoc**************************************************

**
** Symbolic math system flags:
**
DEFINE fnSolutions	ONE		( solution mode )
DEFINE fnConstants	TWO		( constants mode )
DEFINE fnResults	THREE		( results mode )
DEFINE fnCareful	FOUR		( careful evaluation mode )

**
** Binary integer math system flags:
**
DEFINE fnBinWordS1	FIVE		( binary integer wordsize )
  ( must start on nibble boundary )
DEFINE fnBinWordS2	SIX
DEFINE fnBinWordS3	SEVEN
DEFINE fnBinWordS4	EIGHT
DEFINE fnBinWordS5	NINE
DEFINE fnBinWordS6	TEN
DEFINE fnBinBase1	ELEVEN		( binary integer base )
  ( must follow "fnBinWordS6" )
DEFINE fnBinBase2	TWELVE

**
** Floating-point math system flags:
**
DEFINE fnPmtMode	FOURTEEN	( financial BEGIN/END mode )
DEFINE fnComVecDi1	FIFTEEN		( complex number and vector
					mode )
DEFINE fnComVecDi2	SIXTEEN
DEFINE fnAngle1		SEVENTEEN	( angle mode )
  ( must start on a nibble boundary )
DEFINE fnAngle2		EIGHTEEN
DEFINE fnComplex2D	NINETEEN	( complex 2D mode )
DEFINE fnUnderfAct	TWENTY		( underflow action )
DEFINE fnOverfAct	TWENTYONE	( overflow action )
DEFINE fnInfResAct	TWENTYTWO	( infinite result action )
DEFINE fnUnderfNeg	TWENTYTHREE	( underflow-negative indicator )
DEFINE fnUnderfPos	TWENTYFOUR	( underflow-positive indicator )
DEFINE fnOverflow	TWENTYFIVE	( overflow indicator )
DEFINE fnInfResult	TWENTYSIX	( infinite result indicator )
DEFINE fnSymbCx         TWENTYSEVEN     ( symbolic-comples decompilation )
**
** Plotting, I/O, and printing system flags:
**
DEFINE fnSimuPlot	TWENTYEIGHT	( simultaneous plot mode )
DEFINE fnAxesPlot	TWENTYNINE	( axis drawing plot mode )

DEFINE fnConnectPt	THIRTYONE	( connect points mode )
DEFINE fnGCursor        THIRTYTWO	( graphics cursor type mode )
DEFINE fnIODevice	THIRTYTHREE	( I/O device )
DEFINE fnPrintDev	THIRTYFOUR	( print device )
DEFINE fnIODataFmt	THIRTYFIVE	( I/O data format )
DEFINE fnOverwrite      THIRTYSIX	( variable overwrite mode )
DEFINE fnDblSpace	THIRTYSEVEN	( double-space print mode )
DEFINE fnNoAutoCR	THIRTYEIGHT	( suppress auto CR mode )
DEFINE fnNoIOStsMsg	THIRTYNINE	( suppress I/O status messages )


**
** Time management system flags:
**
DEFINE fnClockOn	FORTY		( clock display mode )
DEFINE fnClockFmt	FORTYONE	( clock display format )
DEFINE fnDateFmt	FORTYTWO	( date format )
DEFINE fnResRepAlm	FORTYTHREE	( reschedule unacknowledged
					repeat alarms mode )
DEFINE fnDelNRAlm	FORTYFOUR	( delete acknowledged non-repeat
					alarms mode )

**
** Display format system flags:
**
DEFINE fnNumDigs1	FORTYFIVE	( number of decimal digits )
  ( must start on nibble boundary )
DEFINE fnNumDigs2	FORTYSIX
DEFINE fnNumDigs3	FORTYSEVEN
DEFINE fnNumDigs4	FIRTYEIGHT
DEFINE fnNumDisp1	FORTYNINE	( number display format )
  ( must start on nibble boundary )
DEFINE fnNumDisp2	FIFTY
DEFINE fnRadix		FIFTYONE	( radix mark )
DEFINE fnMultiDisp	FIFTYTWO	( multi-line display mode )
DEFINE fnShowPrec	FIFTYTHREE	( show precedence mode )
DEFINE fnIgnoreTiny	FIFTYFOUR	( zero out tiny matrix elements )

**
** Miscellaneous system flags:
**
DEFINE fnLastArgs	FIFTYFIVE	( last arguments mode )
DEFINE fnErrorBeep	FIFTYSIX	( error beep mode )
DEFINE fnAlarmBeep	FIFTYSEVEN	( alarm beep mode )
DEFINE fnVerbose	FIFTYEIGHT	( verbose display mode )
DEFINE fnNameOnly	FIFTYNINE	( variable name only mode  )
DEFINE fnTriAlpha	SIXTY		( 3-way alpha mode )
DEFINE fnTriUser	SIXTYONE	( 3-way user keys mode )
DEFINE fnUserKeys	SIXTYTWO	( user keys mode )
DEFINE fnNoParse	SIXTYTHREE	( special parser mode )
DEFINE fnIndexWrap	SIXTYFOUR	( index wraparound indicator )




**miscdoc+**************************************************
************************************************************
**
** System flag assembly number assignments
**
**   See "System flag RPL number assignments" for flag
**   descriptions
**
************************************************************
**+miscdoc**************************************************

ASSEMBLE
**
** Symbolic math system flags:
**
SolutionsFl  EQU 1
ConstantsFl  EQU 2
ResultsFl    EQU 3
CarefulFl    EQU 4

**
** Binary integer math system flags:
**
BinWordSFl1  EQU 5	must start on a nibble boundary
BinWordSBCt  EQU 6	number of bits
** Flag 2    EQU 6
** Flag 3    EQU 7
** Flag 4    EQU 8
** Flag 5    EQU 9
** Flag 6    EQU 10
BinBaseFl1   EQU 11	must follow "BinWordSFl6"
BinBaseBCt   EQU 2	number of bits
** Flag 2    EQU 12

**
** Floating-point math system flags:
**
ComVecDiFl1  EQU 15
ComVecDiBCt  EQU 2	number of bits
** Flag2     EQU 16
AngleFl1     EQU 17	must start on a nibble boundary
AngleBCt     EQU 2	number of bits
** Flag2     EQU 18
Complex2DFl  EQU 19
UnderfActFl  EQU 20
OverfActFl   EQU 21
InfResActFl  EQU 22
UnderfNegFl  EQU 23
UnderfPosFl  EQU 24
OverflowFl   EQU 25
InfResultFl  EQU 26

**
** Plotting, I/O, and printing system flags:
**
FunctPlotFl  EQU 30
ConnectPtFl  EQU 31
GCursorFl    EQU 32
IODeviceFl   EQU 33
PrintDevFl   EQU 34
IODataFmtFl  EQU 35
OverwriteFl  EQU 36
DblSpaceFl   EQU 37
NoAutoCRFl   EQU 38
NoIOStsMsgFl EQU 39

**
** Time management system flags:
**
ClockOnFl    EQU 40
ClockFmtFl   EQU 41
DateFmtFl    EQU 42
ResRepAlmFl  EQU 43
DelNRAlmFl   EQU 44

**
** Display format system flags:
**
NumDigsFl1   EQU 45	must start on a nibble boundary
NumDigsBCt   EQU 4	number of bits
** Flag2     EQU 46
** Flag3     EQU 47
** Flag4     EQU 48
NumDispFl1   EQU 49	must start on a nibble boundary
NumDispBCt   EQU 2	number of bits
** Flag2     EQU 50
RadixFl      EQU 51
MultiDispFl  EQU 52
ShowPrecFl   EQU 53

**
** Miscellaneous system flags:
**
LastArgsFl   EQU 55
ErrorBeepFl  EQU 56
AlarmBeepFl  EQU 57
VerboseFl    EQU 58
FastEqViewFl EQU 59
TriAlphaFl   EQU 60
TriUserFl    EQU 61
UserKeysFl   EQU 62
NoParseFl    EQU 63
IndexWrapFl  EQU 64


**miscdoc+**************************************************
************************************************************
**
**  System flag computed nibble and bit assignments
**
************************************************************
**+miscdoc**************************************************

AlarmBeepNib EQU ((AlarmBeepFl)-1)/4
AlarmBeepBit EQU ((AlarmBeepFl)-1)%4

AngleNib     EQU ((AngleFl1)-1)/4
AngleBit1    EQU ((AngleFl1)-1)%4
AngleBit2    EQU (AngleBit1)+1

BinBaseNib   EQU ((BinBaseFl1)-1)/4
BinBaseBit1  EQU ((BinBaseFl1)-1)%4

BinWordSNib  EQU ((BinWordSFl1)-1)/4
BinWordSBit1 EQU ((BinWordSFl1)-1)%4

CarefulNib   EQU ((CarefulFl)-1)/4
CarefulBit   EQU ((CarefulFl)-1)%4

ClockFmtNib  EQU ((ClockFmtFl)-1)/4
ClockFmtBit  EQU ((ClockFmtFl)-1)%4

ClockOnNib   EQU ((ClockOnFl)-1)/4
ClockOnBit   EQU ((ClockOnFl)-1)%4

Complex2DNib EQU ((Complex2DFl)-1)/4
Complex2DBit EQU ((Complex2DFl)-1)%4

ComVecDiNib  EQU ((ComVecDiFl1)-1)/4
ComVecDiBit1 EQU ((ComVecDiFl1)-1)%4

ConnectPtNib EQU ((ConnectPtFl)-1)/4
ConnectPtBit EQU ((ConnectPtFl)-1)%4

ConstantsNib EQU ((ConstantsFl)-1)/4
ConstantsBit EQU ((ConstantsFl)-1)%4

DateFmtNib   EQU ((DateFmtFl)-1)/4
DateFmtBit   EQU ((DateFmtFl)-1)%4

DblSpaceNib  EQU ((DblSpaceFl)-1)/4
DblSpaceBit  EQU ((DblSpaceFl)-1)%4

DelNRAlmNib  EQU ((DelNRAlmFl)-1)/4
DelNRAlmBit  EQU ((DelNRAlmFl)-1)%4

ErrorBeepNib EQU ((ErrorBeepFl)-1)/4
ErrorBeepBit EQU ((ErrorBeepFl)-1)%4

FastEViewNib EQU ((FastEqViewFl)-1)/4
FastEViewBit EQU ((FastEqViewFl)-1)%4

FunctPlotNib EQU ((FunctPlotFl)-1)/4
FunctPlotBit EQU ((FunctPlotFl)-1)%4

GCursorNib   EQU ((GCursorFl)-1)/4
GCursorBit   EQU ((GCursorFl)-1)%4

IndexWrapNib EQU ((IndexWrapFl)-1)/4
IndexWrapBit EQU ((IndexWrapFl)-1)%4

InfResActNib EQU ((InfResActFl)-1)/4
InfResActBit EQU ((InfResActFl)-1)%4

InfResultNib EQU ((InfResultFl)-1)/4
InfResultBit EQU ((InfResultFl)-1)%4

IODataFmtNib EQU ((IODataFmtFl)-1)/4
IODataFmtBit EQU ((IODataFmtFl)-1)%4

IODeviceNib  EQU ((IODeviceFl)-1)/4
IODeviceBit  EQU ((IODeviceFl)-1)%4

LastArgsNib  EQU ((LastArgsFl)-1)/4
LastArgsBit  EQU ((LastArgsFl)-1)%4

VerboseNib   EQU ((VerboseFl)-1)/4
VerboseBit   EQU ((VerboseFl)-1)%4

MultiDispNib EQU ((MultiDispFl)-1)/4
MultiDispBit EQU ((MultiDispFl)-1)%4

NoAutoCRNib  EQU ((NoAutoCRFl)-1)/4
NoAutoCRBit  EQU ((NoAutoCRFl)-1)%4

NoIOStMsgNib EQU ((NoIOStsMsgFl)-1)/4
NoIOStMsgBit EQU ((NoIOStsMsgFl)-1)%4

NoParseNib   EQU ((NoParseFl)-1)/4
NoParseBit   EQU ((NoParseFl)-1)%4

NumDigsNib   EQU ((NumDigsFl1)-1)/4
NumDigsBit1  EQU ((NumDigsFl1)-1)%4

NumDispNib   EQU ((NumDispFl1)-1)/4
NumDispBit1  EQU ((NumDispFl1)-1)%4

OverfActNib  EQU ((OverfActFl)-1)/4
OverfActBit  EQU ((OverfActFl)-1)%4

OverflowNib  EQU ((OverflowFl)-1)/4
OverflowBit  EQU ((OverflowFl)-1)%4

OverwriteNib EQU ((OverwriteFl)-1)/4
OverwriteBit EQU ((OverwriteFl)-1)%4

PrintDevNib  EQU ((PrintDevFl)-1)/4
PrintDevBit  EQU ((PrintDevFl)-1)%4

RadixNib     EQU ((RadixFl)-1)/4
RadixBit     EQU ((RadixFl)-1)%4

ResRepAlmNib EQU ((ResRepAlmFl)-1)/4
ResRepAlmBit EQU ((ResRepAlmFl)-1)%4

ResultsNib   EQU ((ResultsFl)-1)/4
ResultsBit   EQU ((ResultsFl)-1)%4

ShowPrecNib  EQU ((ShowPrecFl)-1)/4
ShowPrecBit  EQU ((ShowPrecFl)-1)%4

SolutionsNib EQU ((SolutionsFl)-1)/4
SolutionsBit EQU ((SolutionsFl)-1)%4

TriAlphaNib  EQU ((TriAlphaFl)-1)/4
TriAlphaBit  EQU ((TriAlphaFl)-1)%4

TriUserNib   EQU ((TriUserFl)-1)/4
TriUserBit   EQU ((TriUserFl)-1)%4

UnderfActNib EQU ((UnderfActFl)-1)/4
UnderfActBit EQU ((UnderfActFl)-1)%4

UnderfNegNib EQU ((UnderfNegFl)-1)/4
UnderfNegBit EQU ((UnderfNegFl)-1)%4

UnderfPosNib EQU ((UnderfPosFl)-1)/4
UnderfPosBit EQU ((UnderfPosFl)-1)%4

UserKeysNib  EQU ((UserKeysFl)-1)/4
UserKeysBit  EQU ((UserKeysFl)-1)%4

RPL
RPL		( insure RPL-mode exit )
** Non-Macro Property Lists Symbols 1.1
**miscdoc+**************************************************
************************************************************ 
**
** File:    PropList.h Version 1.1, 10/27/89
** Machine: Charlemagne
**
************************************************************
**+miscdoc**************************************************

**miscdoc+**************************************************
************************************************************ 
**
**	This file contains equates defining 
**	property-list bits and parse-data for non-macro 
**      romwords.  (Equates for macros are defined elsewhere.)
**
************************************************************
**
**  History:	6 JUL 88	Created by CP & MJ
**
************************************************************
**+miscdoc**************************************************

**miscdoc+**************************************************
************************************************************ 
**
**	Equates for Property-List Bits
**
**	These equates (and the implied order of the properties) 
**	must be consistent with the property-list bits for 
**	macros as defined elsewhere.
**
************************************************************
**+miscdoc**************************************************
ASSEMBLE

* most significant nibble equates:

nonALG EQU 8			not-allowed-in-algebraics flag 
hasHELP EQU 4			has-help-data flag
hasPROMPTM EQU 4		same as above
hasALIAS EQU 2			has-algebraic-alias flag
hasPDATA EQU 1			has-parse-data flag

* the remaining equates are only relevant for algebraic functions.
* next most significant nibble equates:

hasDER EQU 8			has-derivative flag
hasINV EQU 4			has-inverse flag
hasCOLCT EQU 2			has-COLCT-data flag
hasEXPND EQU 1			has-EXPND-data flag

* least significant nibble equates:

hasFORM EQU 8			has-FORM-menu flag
hasINTG EQU 4			has-Integral-data flag
hasWHERE EQU 2			has-WHERE-code flag
hasVUNS EQU 1			has-veryunsymin-code flag

**miscdoc+**************************************************
************************************************************ 
**
**	Equates for Parse-Data
**
**	Each equate name has the structure:
**
**		 pd<component abbreviation>
**
**	where the component abbreviation is that of the ERS
**	section on parsing symbolic objects.
**
************************************************************
**+miscdoc**************************************************

pdEX EQU #0		general expression
pdOP EQU #1		operator
pdQE EQU #2		quoted expression
pdQN EQU #3		quoted name
pdLP EQU #4		left parenthesis
pdRP EQU #5		right parenthesis
pdCM EQU #6		comma (non-radix)
pdEQ EQU #7		equal-sign separator
pdOS0 EQU #8		optional repeat 0
pdOS1 EQU #9		optional repeat 1
pdOS2 EQU #A		optional repeat 2
pdOS3 EQU #B		optional repeat 3
pdOS4 EQU #C		optional repeat 4
pdOS5 EQU #D		optional repeat 5
pdOS6 EQU #E		optional repeat 6
pdOS7 EQU #F		optional repeat 7

RPL
RPL		( insure RPL-mode exit )
**	TITLE Key Code and Plane Definitions 1.1
**miscdoc+**************************************************
************************************************************
**
** The key plane definitions here are listed in numerical
** order.  All names begin with "kp" (to indicate a "k"ey 
** "p"lane), and the names describe the key plane specified.
**
************************************************************
**+miscdoc**************************************************

DEFINE kpNoShift	ONE
DEFINE kpLeftShift	TWO
DEFINE kpRightShift	THREE
DEFINE kpANoShift	FOUR
DEFINE kpALeftShift	FIVE
DEFINE kpARightShft	SIX

**miscdoc+**************************************************
************************************************************
**
** The key code definitions here are listed in numerical
** order.  All names begin with "kc" (to indicate a "k"ey 
** "c"ode), and names are chosen to best describe the primary
** operation of the key.
**
************************************************************
**+miscdoc**************************************************

DEFINE kcMenuKey1	ONE
DEFINE kcMenuKey2	TWO
DEFINE kcMenuKey3	THREE
DEFINE kcMenuKey4	FOUR
DEFINE kcMenuKey5	FIVE
DEFINE kcMenuKey6	SIX

DEFINE kcMathMenu	SEVEN
DEFINE kcPrgmMenu	EIGHT
DEFINE kcCustomMenu	NINE
DEFINE kcVarsMenu	TEN
DEFINE kcUpArrow	ELEVEN
DEFINE kcNextRow	TWELVE

DEFINE kcTick		THIRTEEN
DEFINE kcSto		FOURTEEN
DEFINE kcEval		FIFTEEN
DEFINE kcLeftArrow	SIXTEEN
DEFINE kcDownArrow	SEVENTEEN
DEFINE kcRightArrow	EIGHTEEN

DEFINE kcSin		NINETEEN
DEFINE kcCos		TWENTY
DEFINE kcTan		TWENTYONE
DEFINE kcSqrt		TWENTYTWO
DEFINE kcPower		TWENTYTHREE
DEFINE kcInverse	TWENTYFOUR

DEFINE kcEnter		TWENTYFIVE
DEFINE kcNegate		TWENTYSIX
DEFINE kcEnterExp	TWENTYSEVEN
DEFINE kcDelete		TWENTYEIGHT
DEFINE kcBackspace	TWENTYNINE

DEFINE kcAlpha		THIRTY
DEFINE kc7		THIRTYONE
DEFINE kc8		THIRTYTWO
DEFINE kc9		THIRTYTHREE
DEFINE kcDivide		THIRTYFOUR

DEFINE kcLeftShift	THIRTYFIVE
DEFINE kc4		THIRTYSIX
DEFINE kc5		THIRTYSEVEN
DEFINE kc6		THIRTYEIGHT
DEFINE kcTimes		THIRTYNINE

DEFINE kcRightShift	FORTY
DEFINE kc1		FORTYONE
DEFINE kc2		FORTYTWO
DEFINE kc3		FORTYTHREE
DEFINE kcMinus		FORTYFOUR

DEFINE kcOn		FORTYFIVE
DEFINE kc0		FORTYSIX
DEFINE kcPeriod		FORTYSEVEN
DEFINE kcSpace		FORTYEIGHT
DEFINE kcPlus		FORTYNINE

DEFINE kcAlphaLeft	FIFTY
RPL		( insure RPL-mode exit )
** 	Charlemagne Equation Writer Constants 1.1
**miscdoc+**************************************************
************************************************************
**
** File:    EQW.h Version 1.1, 10/27/89
** Machine: Charlemagne
**
************************************************************
**+miscdoc**************************************************

** The current GBox number:
DEFINE CurrentGbox#	SEVEN
RPL		( insure RPL-mode exit )

ASSEMBLE
	SETLIST CODE, INCLUDE, PSEUDO, MACRO
RPL
RPL		( insure RPL-mode exit )
